//
//  FWBXDictionary.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 08-1-8.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "FBHDictionary.h"
#import "FWBXUtils.h"

@implementation FBHDictionary

- (id) initWithIndexFile:(NSString*) idxFile listFile:(NSString*) datFile dbFile:(NSString*) dbFile
{
	self = [super init];
	if (self != nil) {
		tree = [[FTree alloc] initFromFile:[idxFile fileSystemRepresentation]];
		list = [[FList alloc] initFromFile:[datFile fileSystemRepresentation] withType:FWBX];
		dtree = [[FDynamicTree alloc] initFromFile:[dbFile fileSystemRepresentation] withType:FWBX];
	}
	return self;
}

-(NSString *) fixInputString:(NSString *) str
{
	return str;
}

-(NSArray *) searchWordsByFixedString:(NSString *) fixedString
{

	// code : 12345 1-h 2-s 3-p 4-dl 5-z

	NSCharacterSet* non_12345_set = [[NSCharacterSet characterSetWithCharactersInString:@"123450"] invertedSet];
	NSCharacterSet* non_dhsplz_set = [[NSCharacterSet characterSetWithCharactersInString:@"dhspnz"] invertedSet];
	NSCharacterSet* non_char_set = [[NSCharacterSet characterSetWithCharactersInString:@"!@#$%?"] invertedSet];
	
	NSRange r = [fixedString rangeOfCharacterFromSet:non_12345_set];
	
	NSString* inputString = fixedString;
	
	if(r.location != NSNotFound){
		r = [fixedString rangeOfCharacterFromSet:non_dhsplz_set];
		if(r.location != NSNotFound){
			r = [fixedString rangeOfCharacterFromSet:non_char_set];
			if(r.location != NSNotFound){
				return [self searchWordsByMutiString:fixedString];
			}else{
				int i; 
				NSMutableString* translated = [NSMutableString string];
				for(i=0;i<[inputString length];i++){
					unichar c = [inputString characterAtIndex:i];
					if(c=='?') [translated appendString:@"0"];
					else if(c=='!') [translated appendString:@"1"];
					else if(c=='@') [translated appendString:@"2"];
					else if(c=='#') [translated appendString:@"3"];
					else if(c=='$') [translated appendString:@"4"];
					else if(c=='%') [translated appendString:@"5"];
				}
				inputString = translated;
			}
		}else{			
			int i; 
			NSMutableString* translated = [NSMutableString string];
			for(i=0;i<[inputString length];i++){
				unichar c = [inputString characterAtIndex:i];
				if(c=='d') [translated appendString:@"4"];
				else if(c=='h') [translated appendString:@"1"];
				else if(c=='s') [translated appendString:@"2"];
				else if(c=='p') [translated appendString:@"3"];
				else if(c=='n') [translated appendString:@"4"];
				else if(c=='z') [translated appendString:@"5"];
			}
			inputString = translated;
		}
	}
	

	UInt32 p[500];
	UInt32 len = 0;
	
	//len = [FWBXUtils getCodeIndexs:p byPYString:inputString];
	len = [FWBXUtils getBHMutiCodeIndexs:p byPYString:inputString];
	
	if(!len) return nil;
	
	NSArray* res;
	
	//res = [FWBXUtils searchWordsByCodeIndexs:p withLength:len withTree:tree withList:list withDynamicTree:dtree];
	res = [FWBXUtils searchWordsByMutiCodeIndexs:p withTree:tree withList:list withDynamicTree:dtree];
	int count = 0;
	while(!res || [res count] == 0){
		int i,k,j=0;
		while(!(p[j]==0 && p[j+1]==0))j++;
		j+=1;
		for(i=0;i<1;i++){
			for(k='1';k<='5';k++){
				p[j] = k;
				j++;
			}
			p[j] = 0;
			j++;
		}
		p[j]=0;
		res = [FWBXUtils searchWordsByMutiCodeIndexs:p withTree:tree withList:list withDynamicTree:dtree];
		count++;
		if(count > 5) break;
	}
	int j = 0;
	while(j<[res count]){
		[[res objectAtIndex:j] setCode:inputString];
		j++;
	}
	
	NSMutableArray* resx = [NSMutableArray arrayWithArray:res];
	[resx sortUsingSelector:@selector(compare:)];
	
	return resx;
}

-(NSArray *) searchWordsByMutiString:(NSString *) fixedString
{
	//NSLog(@"hit");
	NSCharacterSet* non_12345_set = [[NSCharacterSet characterSetWithCharactersInString:@"123450#"] invertedSet];
	NSRange r = [fixedString rangeOfCharacterFromSet:non_12345_set];
	if(r.location != NSNotFound){
		return nil;
	}
	
	UInt32 p[1000];
	UInt32 len = 0;
	
	len = [FWBXUtils getBHMutiCodeIndexs:p byMutiString:fixedString];
	
	NSArray* res = [FWBXUtils searchWordsByMutiCodeIndexs:p withTree:tree withList:list withDynamicTree:dtree];
	int count = 0;
	while(!res || [res count] == 0){
		int i,k,j=0;
		while(!(p[j]==0 && p[j+1]==0))j++;
		j+=1;
		for(i=0;i<1;i++){
			for(k='1';k<='5';k++){
				p[j] = k;
				j++;
			}
			p[j] = 0;
			j++;
		}
		p[j]=0;
		res = [FWBXUtils searchWordsByMutiCodeIndexs:p withTree:tree withList:list withDynamicTree:dtree];
		count++;
		if(count > 5) break;
	}
	
	NSMutableArray* resx = [NSMutableArray arrayWithArray:res];
	[resx sortUsingSelector:@selector(compare:)];
	
	//NSLog(@"code=%@",[[resx objectAtIndex:0] code]);
	
	return resx;

	
}

-(void) addWord:(FWord*) word
{
	[dtree addWord:word];
}

-(void) addWords:(NSArray*) ws
{
	int i;
	for(i=0;i<[ws count];i++){
		FWord* w = [ws objectAtIndex:i];
		[self addWord:w];
	}
}

-(void) removeWord:(FWord *)word
{
	[dtree removeWord:word];
}

-(NSArray*) userWords
{
	return [dtree userWords];
}

-(NSArray*) userWordsForPost
{
	return [dtree userWordsForPost];
}

-(void) userWordsPostDone
{
	[dtree userWordsPostDone];
}


-(void) saveUserWords
{
	[dtree updateDBNow:nil];
}

- (void) dealloc
{
	[tree release];
	[list release];
	[dtree release];
	[super dealloc];
}





@end
