//
//  FDynamicTreeNode.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-28.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FDynamicTreeNode.h"


@implementation FDynamicTreeNode

-(id) initWithCodeIndex:(UInt32)c
{
	self = [super init];
	if (self != nil) {
		codeIndex = c;
		words = nil;
		childs = nil;
	}
	return self;
}

-(NSNumber*) numberForCodeIndex
{
	return [NSNumber numberWithInt:codeIndex];
}

-(NSArray*) words
{
	return words;
}

-(FDynamicTreeNode*) childNodeForCodeIndex:(UInt32) c
{
	if(childs == nil) return nil;
	return [childs objectForKey:[NSNumber numberWithInt:c]];
}

-(void) addChildNode:(FDynamicTreeNode*) node
{
	if(!childs) childs = [[NSMutableDictionary alloc] initWithCapacity:5];
	[childs setObject:node forKey:[node numberForCodeIndex]];
}

-(FWord*) addWord:(FWord*) w
{
	FWord* rw = w;
	if(!words) words = [[NSMutableArray alloc] initWithCapacity:5];
	int i=0;
	int count=[words count];
	for(i=0;i<count;i++){
		FWord* tw = [words objectAtIndex:i];
		if([w isEqualTo:tw]){
			//NSLog(@"w=%@ hit=%d,whit=%d",tw,[tw hit],[w hit]);
			[tw setHit:[tw hit]+[w hit]];
			
			[words sortUsingSelector:@selector(compare:)];
			rw = tw;
			break;
		}
		if([w compare:tw]==NSOrderedAscending) {
			[words insertObject:w atIndex:i];
			break;
		}
	}
	if(i==count) {
		[words addObject:w];
	}
	return rw;
}

-(void) removeWord:(FWord*) w
{
	if(!words) return;
	int i=0;
	int count=[words count];
	for(i=0;i<count;i++){
		FWord* tw = [words objectAtIndex:i];
		if([w isEqualTo:tw]){
			[words removeObjectAtIndex:i];
			break;
		}
	}
	return;	
}

- (void) dealloc
{
	[childs release];
	[words release];
	[super dealloc];
}


@end
