//
//  FInputEngine.h
//  FunInputToy2.0
//
//  Created by Feng Huajun on 08-1-23.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "FPYDictionary.h"
#import "FPYNumDictionary.h"
#import "FWBXDictionary.h"
#import "FBHDictionary.h"
#import "FRelatedWordList.h"
#import "FInputDictionary.h"
#import "FPYUtils.h"
#import "FWord.h"

typedef enum _FInputMode {
	FPYInputMode,
	FWBXInputMode,
	FBHInputMode,
	FPYNumInputMode
} FInputMode;

@interface FInputEngine : NSObject {
	FInputMode currentInputMode;
	BOOL wbxPYMix;
	BOOL tmpPY;
	FPYDictionary* pyDict;
	FWBXDictionary* wbxDict;
	FBHDictionary* bhDict;
	FRelatedWordList* relatedDict;
	FPYNumDictionary* pyNumDict;
	id<FInputDictionary> currentDict;
	NSCharacterSet* non_dhsplz_set;
	NSCharacterSet* non_char_set;
	BOOL tmpBH;
}

-(id) initWithDataPath:(NSString*) dataPath withUserPath:(NSString*) userDataPath withSetting:(NSDictionary*)setting;
-(FInputMode) currentInputMode;
-(void) reloadSetting:(NSDictionary*)setting;
-(void) setInputMode:(FInputMode) m;
-(NSString*) fixString:(NSString*)s;
-(NSArray*) wordsSearchByFixedString:(NSString*)s;
-(NSArray*) relatedWordsByString:(NSString*) s;
-(void) addWord:(FWord*) word;
-(void) addWords:(NSArray*) ws;
-(void) removeWord:(FWord *)word;
-(NSArray*) userWords;
-(void) saveUserWords;
@end
