//
//  FList.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-23.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FList.h"
#import "FMutableTree.h"
#import <sys/stat.h>
#import <sys/mman.h>

@implementation FList

+(UInt32) saveWordArray:(NSArray*) array withType:(int)wtype toListFile:(const char*) listfilename  andIndexFile:(const char*) indexfilename
{
	FMutableTree* tree = [[FMutableTree alloc] initWithArraySize:[array count]*50];
	FILE* fps = fopen(listfilename, "w+");
	unichar buffer[100];
	NSString* s;
	NSString* c = @"";
	unichar freq;
	unichar t = FLIST_TERMINAL_FLAG;
	unichar pt = 0;
	int count = 0;
	UInt32 index=0;
	UInt32 cc[100];
	NSEnumerator* e = [array objectEnumerator];
	FWord* w;
	while ( w = [e nextObject]) {
	    if(![c isEqualToString:[w code]]){
			UInt32 len = [w genCodeArray:cc];
			if(len<=0) {
				//NSLog(@"ignore %@ %@",[w code],[w string]);
				continue;
			}
			if(![c isEqualToString:@""])
			{
				fwrite(&t, sizeof(unichar),1, fps);
				index += 1;
			}
			[tree addNodeWithWordIndex:index withCodeIndexs:cc withLength:len];
		}
		
		s = [w string];
		[s getCharacters:buffer];
		fwrite(buffer, sizeof(unichar),[s length], fps);
		index += [s length];
		if(wtype==FWBX){
			fwrite(&pt,sizeof(unichar),1, fps);
			index++;
		}
		freq = (unichar) [w freq];		
		fwrite(&freq, sizeof(unichar), 1, fps);
		index += 1;

		//NSLog(@"%@ => %@,freq=%d, %d",[w code], [w string], [w freq], sizeof(unichar));
		c = [w code];
		count++;
		//if(count>1000) break;
	}
	fwrite(&t, sizeof(unichar),1, fps);
	//NSLog(@"word count = %d",count);
	fclose (fps);
	//NSLog(@"tree=%@",tree);
	[tree saveToFile:indexfilename];
	[tree release];
	return count;
	
}

-(id) initFromFile:(const char*) filename withType:(int) t 
{
	self = [super init];
	if (self != nil) {
		type = t;
		fd = -1;
		struct stat statbuf;
		int r;
		fd = open(filename,O_RDONLY);
		if(fd==-1){
			fprintf(stderr,"could not open %s: error %d (%s)\n", filename, errno, strerror(errno));
			exit(1);
		}
		r = fstat(fd,&statbuf);
		if(r==-1){
			fprintf(stderr,"fstat %s failed: error %d (%s)\n", filename, errno, strerror(errno));
			exit(1);
		}
		length = statbuf.st_size;
		#ifndef IPHONE
		pchar = mmap(NULL, length, PROT_READ, MAP_PRIVATE, fd, 0);
		if((caddr_t)pchar==(caddr_t)-1){
			fprintf(stderr,"mmap %s failed: error %d (%s)\n", filename, errno, strerror(errno));
			exit(1);
		}
		
		#else
		NSError* error;
		data = [[NSData alloc] initWithContentsOfFile:[NSString stringWithUTF8String:filename] options:NSMappedRead error:&error];
		pchar = [data bytes]; //malloc(length);
		length = [data length];
		
		
		/*
		if(read(fd, pchar, length) == (ssize_t)-1){
			fprintf(stderr,"reading %s failed: error %d (%s)\n", filename, errno, strerror(errno));
			exit(1);
		}
		 */
		
		#endif
		
	}
	return self;
}


-(NSArray*) wordArrayByIndex:(UInt32) windex withLength:(UInt32) len limit:(int) limitNum
{
	UInt32 i=windex;
	//NSLog(@"Word Index = %d,%@",windex,test);
	NSMutableArray* res = [NSMutableArray array];
	while(pchar[i] != FLIST_TERMINAL_FLAG){
		if(type==FWBX){
			len = 1;
			while(pchar[i+len])len++;
		}
		NSString* str = [NSString stringWithCharacters:&pchar[i] length:len];
		i += len;
		if(type==FWBX) i++;
		unichar freq = pchar[i];
		i++;
		FWord* w = [FWordFactory genNewWord:type];
		[w setCode:@""];
		[w setString:str];
		[w setFreq:freq];
		[res addObject:w];
		if(limitNum!=0 && [res count]>limitNum ) break;
		//NSLog(@"w=%@,f=%d",str, freq);
	}
	return res;
}

- (void) dealloc
{
	if(fd!=-1){
		#ifndef IPHONE
		munmap(pchar, length);
		#endif
		close(fd);
	}
	if(!data) [data release];
	[super dealloc];
}

@end
