//
//  FMutableTree.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-22.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FMutableTree.h"


@implementation FMutableTree


- (id) initWithArraySize:(UInt32) s
{
	self = [super init];
	if (self != nil) {
		fd = -1;
		size = s;
		count = 1;
		treeArray = malloc(sizeof(FTreeNode)*s);
		bzero(treeArray, sizeof(FTreeNode)*s);
	}
	return self;
}

-(UInt32) searchByCodeIndex:(UInt32) c withParentIndex: (UInt32) parentIndex
{
	FTreeNode* parent = &treeArray[parentIndex];
	UInt32 i, r;
	i = parent->firstChild;
	r = -1;
	while(i!=0){
		if(treeArray[i].codeIndex == c) {
			r = i;
			break;
		}
		i = treeArray[i].nextSibling;
	}
	return r;
}


-(UInt32) addChild:(FTreeNode) node withParentIndex: (UInt32) parentIndex
{
	treeArray[count].codeIndex = node.codeIndex;
	treeArray[count].wordIndex = node.wordIndex;
	treeArray[count].parent = parentIndex;
	treeArray[count].firstChild = 0;
	treeArray[count].nextSibling = 0;
		
	FTreeNode* parent = &treeArray[parentIndex];
	
	UInt32 i;
	i = parent->firstChild;
	
	if(i==0){
		parent->firstChild = count;
	}else{
		FTreeNode* n;
		while(i!=0){
			n = &treeArray[i];
			i = treeArray[i].nextSibling;
		}
		n->nextSibling = count;
	}
	count++;
	return count - 1;
}

-(UInt32) addChildWithCodeIndex:(UInt32) c withParentIndex: (UInt32) parentIndex
{
	FTreeNode node;
	node.codeIndex = c;
	node.wordIndex = -1;
	return [self addChild:node withParentIndex:parentIndex];
}

-(UInt32) addNodeWithWordIndex:(UInt32) w withCodeIndexs: (UInt32*) cc withLength:(UInt32) len
{
	int i=0;
	UInt32 parentIndex = 0, p;
	UInt32 j = len-1;
	for(i=0;i<j;i++){
		UInt32 c = cc[i];
		p = [self searchByCodeIndex:c withParentIndex:parentIndex];
		if(p == -1 && i < len-1){
			p = [self addChildWithCodeIndex:c withParentIndex:parentIndex];
		}
		parentIndex = p;
	}
	FTreeNode node;
	node.codeIndex = cc[j];
	node.wordIndex = w;
	return [self addChild:node withParentIndex:parentIndex];
}

-(void) saveToFile:(const char*) filename
{
	FILE* fps = fopen(filename, "w+");
	fwrite(treeArray, sizeof(FTreeNode),count, fps);
	fclose (fps);
}

- (void) dealloc
{
	if(fd==-1){
		free(treeArray);
	}
	[super dealloc];
}

@end
