//
//  FPYNumDictionary.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 08-2-25.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "FPYNumDictionary.h"
#import "FPYUtils.h"

typedef struct _sstat {
	NSString* str;
	int p;
	int len;
	int mlen;
} sstat;

@implementation FPYNumDictionary

-(id) initWithPYDict:(FPYDictionary*) dict
{
	self = [super init];
	if (self != nil) {
		pyDict = [dict retain];
							  //abcdefghijklmnopqrstuvwxyz
		numString = [@"22233344455566677778889999" retain];
		numPYDict = [[NSMutableDictionary alloc] init];
		numSet = [[NSMutableSet alloc] init];
		tree = [[pyDict tree] retain];
		list = [[pyDict list] retain];
		dtree = [[pyDict dtree] retain];
		
		[self reloadNumPYDict];
		
	}
	return self;
}


-(NSString*) numStringByYin:(NSString*) yin
{
	int i;
	unichar c;
	NSMutableString* nstr = [NSMutableString string];
	for(i=0;i<[yin length];i++){
		c = [yin characterAtIndex:i];
		[nstr appendFormat:@"%c",[numString characterAtIndex:c-'a']];
	}
	return nstr;
}

-(void) reloadNumPYDict
{
		NSSet* pySet = [FPYUtils pinYinSet];
		[numPYDict removeAllObjects];
		[numSet removeAllObjects];
		NSEnumerator* e = [pySet objectEnumerator];
		NSString* yin;
		
		while(yin = [e nextObject]){
			NSString* nyin = [self numStringByYin:yin];
			NSMutableArray* ys = [numPYDict objectForKey:nyin];
			if(!ys){
				ys = [NSMutableArray array];
				[numPYDict setObject:ys forKey:nyin];
				[numSet addObject:nyin];
			}
			[ys addObject:yin];
		}

		//NSLog(@"numPYDict = %@", numPYDict);
		//NSLog(@"fixed %@", [self fixInputString:@"222"]);
}

-(NSString *) fixInputString:(NSString *) s
{
	NSMutableString* str = [NSMutableString string];
	NSArray* strs = [s componentsSeparatedByString:@"'"];
	NSEnumerator* e = [strs objectEnumerator];
	NSString* es;
	while(es = [e nextObject]){
		if([str length]) [str appendString:@"'"];
		[str appendString:[self fixInputString2:es]];
	}
	return str;
}

-(NSString *) fixInputString2:(NSString *) s
{

	if([s length]<2 || [numSet containsObject:s] ) return s;
	
	NSMutableString* str = [NSMutableString string];

	sstat stack[100];
	int i=0;
	
	int p=0;
	int len=1;
	int mlen=999;
	NSRange range;
	
	int min_count=999;
	NSString* mstr = nil;
	
	while(p+len<=[s length]){
			range.location = p;
			range.length = len;
			NSString * tmp = [s substringWithRange:range];
			if([numSet containsObject:tmp]){
					stack[i].str = [NSString stringWithString:str];
					stack[i].p = p;
					stack[i].len = len;
					stack[i].mlen = mlen;
					i++;
					if([tmp length] < mlen) mlen = [tmp length];
					if([str length]) [str appendString:@"'"];
					[str appendString:tmp];					
					p+=len;
					len = 1;
					if(p==[s length]){
						//NSLog(@"%@,len=%d,mlen=%d",str,i,mlen);
						
						if(mstr==nil||(i<min_count && mlen!=1)){
							min_count = i;
							mstr = [NSString stringWithString:str];
						}
						if(i>1){
							i-=2;
							[str setString:stack[i].str];
							p = stack[i].p;
							len = stack[i].len;
							mlen = stack[i].mlen;
							//NSLog(@"b-%@,p=%d,len=%d",str,p,len);
							len ++;
						}
					}
					
			}else{
					if(len <= 6 && p + len < [s length]){
						len++;
					}else{
						i--;
						if(i<0) break;
						[str setString:stack[i].str];
						p = stack[i].p;
						len = stack[i].len;
						mlen = stack[i].mlen;
						len ++;
					}
			}
			
	}
	
	if(mstr) return mstr;
	
	NSCharacterSet* nonLetterSet = [NSCharacterSet characterSetWithCharactersInString:@"'"];
	
	[str setString:s];
	
	p = 0;
	len = [str length];
	if(len>6)len=6;
	
	
	while(p<[str length]){
		while(len>0){
			range.location = p;
			range.length = len;
			NSString * tmp = [str substringWithRange:range];
			NSRange r = [tmp rangeOfCharacterFromSet:nonLetterSet];
			if(r.location==NSNotFound && (len==1||[numSet containsObject:tmp])){  
				p+=len;
				if(p<[str length]&&[str characterAtIndex:p]!='\'')[str insertString:@"'" atIndex:p];
				break;
			}
			len--;
		}
		p++;
		len=[str length] - p;
		if(len>6)len=6;
	}

	return str;

}

-(NSString*) simpleCode: (NSString* ) code
{
	char str[100];
	const char* c = [code UTF8String];
	int len = [code length];
	int i;
	int j=0;
	for(i=0;i<len;i++){
		if(i!=0 &&  c[i] == 'h' && (c[i-1]=='z' || c[i-1]=='s' || c[i-1]=='c')) continue;
		if(i!=0 && c[i] == 'g' && c[i-1] == 'n')  continue;
		str[j] = c[i];
		j++;
	} 
	str[j]=0;
	return [NSString stringWithUTF8String:str];
}

-(NSMutableArray *) yinArraybyString: (NSString *) str
{
	NSArray* yins = [[str stringByTrimmingCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@"'"]] componentsSeparatedByString:@"'"];
	NSMutableArray* res = [NSMutableArray array];
	
	int i;
	for(i=0;i<[yins count];i++){
		NSMutableArray* yinsForNum = [numPYDict objectForKey:[yins objectAtIndex:i]];
		if(!yinsForNum && [[yins objectAtIndex:i] length] == 1){
			yinsForNum = [NSMutableArray array];
			int jj;
			unichar c = [[yins objectAtIndex:i]  characterAtIndex:0];
			for(jj=0;jj<[numString length];jj++){
				if(c == [numString characterAtIndex:jj]){
					[yinsForNum addObject:[NSString stringWithFormat:@"%c",'a'+jj]]; 
				}
			}
		}
		if(![res count]){
			[res addObjectsFromArray:yinsForNum];
			continue;
		}
		NSMutableArray* resx = [NSMutableArray array];
		int j;
		for(j=0;j<[yinsForNum count];j++){
			int k;
			for(k=0;k<[res count];k++){
				NSString* s = [[res objectAtIndex:k] stringByAppendingFormat:@"'%@", [yinsForNum objectAtIndex:j]];
				[resx addObject:s];
			}
		}
		res = resx;
	}
	return res;
}

-(NSArray *) searchWordsByFixedString:(NSString *) fixedString
{


	NSCharacterSet* non_num_set = [[NSCharacterSet characterSetWithCharactersInString:@"23456789'"] invertedSet];
	
	NSRange r = [fixedString rangeOfCharacterFromSet:non_num_set];
	
	if(r.location != NSNotFound){
		return [pyDict searchWordsByFixedString:fixedString];
	}
	
	NSString* str = [fixedString stringByTrimmingCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@"'"]];
	NSArray* nys = [str componentsSeparatedByString:@"'"];
	NSString* ny;
	int ni;
	BOOL limit = NO;
	for(ni=[nys count]-1;ni>=0;ni--){
		ny = [nys objectAtIndex:ni];
		if([ny length]==1){
			limit = YES;
			break;
		}
		
	}
	
	NSMutableArray* ccodes = [self yinArraybyString:fixedString];
	if(limit){
		return [[NSArray arrayWithObject:[self codeWordByArray:ccodes]] arrayByAddingObjectsFromArray: [pyDict searchWordsByFixedString:[ccodes objectAtIndex:0]]];
	}

	UInt32 p[1000];
	UInt32 len = 0;
	
	
	
	
	int i=0;

	
	for(ni=[nys count]-1;ni>=0;ni--){
		ny = [nys objectAtIndex:ni];
		NSMutableArray* ys = [numPYDict objectForKey:ny];
		
		if(!ys && [ny length]==1){
			ys = [NSMutableArray array];
			int j;
			for(j=0;j<[numString length];j++){
				if([ny characterAtIndex:0] == [numString characterAtIndex:j]){
					NSArray* mys = [FPYUtils qpMutipleCodeElement:[NSString stringWithFormat:@"%c",'a'+j]];
					[ys addObjectsFromArray:mys]; 
				}
			}
		}else{
		   NSMutableArray* yss = [NSMutableArray array];
		   int j;
		   for(j=0;j<[ys count];j++){
				NSArray* mys = [FPYUtils qpMutipleCodeElement:[ys objectAtIndex:j]];
				[yss addObjectsFromArray:mys];
		   }
		   ys = yss;
		}
		//NSLog(@"ys = %@", ys);
		NSEnumerator* e2 = [ys objectEnumerator];
		NSString* y;
		while(y = [e2 nextObject]){
			p[i] = [FPYUtils codeIndexFor:y];
			if(p[i]==0) continue;
			i++;
		}
		p[i]=0;
		i++;
		len ++;
	}
	p[i] = 0;
	i++;
	
	/*
	i=0;
	while(!(p[i]==0 && p[i+1]==0)){
		printf("p[%d]=%d\n",i,p[i]);
		i++;
	}
	*/
	
	FWord* firstWord = nil;
	NSArray* candidateWords = [FPYUtils searchWordsByMutiCodeIndexs:p withDynamicTreeOnly:dtree];
	//NSLog(@"cws = %@",candidateWords);
	NSMutableArray* res = [NSMutableArray arrayWithArray:candidateWords];
	//NSLog(@"res = %@",res);
	[res sortUsingSelector:@selector(compare:)];
	if(res && [res count])
		firstWord = [res objectAtIndex:0];
	//NSLog(@"res = %@",res);
	if(firstWord==nil || len!=[[firstWord string] length]){
	  firstWord = [FPYUtils guestFirstWordWithMutiCodeIndexs:p withFirstWord:firstWord withTree:tree withList:list withDynamicTree:dtree];
	  [res insertObject:firstWord atIndex:0];
	}
	//NSLog(@"res = %@",res);
	firstWord = [res objectAtIndex:0];
	
	NSString* scode = [self simpleCode:[firstWord code]];
	
	
	for(i=0;i<[ccodes count];i++){
		NSString* t_scode = [self simpleCode:[ccodes objectAtIndex:i]];
		if([scode hasPrefix:t_scode]){
			[ccodes insertObject:[ccodes objectAtIndex:i] atIndex:0];
			[ccodes removeObjectAtIndex:i+1];
			break;
		}
		
	}
	
	//[self addFirstYinWordsTo:res byCodeArray:ccodes];
	
	[res insertObject:[self codeWordByArray:ccodes]  atIndex:0];
	
	return res;


}

-(FWord*) codeWordByArray:(NSArray *) codes
{
	FWord* w = [[[FWord alloc] init] autorelease];
	[w setCode:@"codes"];
	NSMutableString* c = [NSMutableString string];
	int i;
	for(i=0;i<[codes count];i++){
		if([c length])[c appendString:@"|"];
		[c appendString:[codes objectAtIndex:i]];
		if(i>20) break;
	}
	[w setString:c];
	return w;
}

-(void) addFirstYinWordsTo:(NSMutableArray *) res byCodeArray:(NSArray *) codes
{
	NSString* firstYin = [[[codes objectAtIndex:0] componentsSeparatedByString:@"'"] objectAtIndex:0];
	NSArray* fres = [pyDict searchWordsByFixedString:firstYin];
	[res addObjectsFromArray:fres];
	int i = 0;
	NSMutableSet* addset = [NSMutableSet set];
	while(i < [res count] && i < 20){
		FWord* w = [res objectAtIndex:i];
		if([addset containsObject:[w string]]){
			[res removeObjectAtIndex:i];
		}else{
			[addset addObject:[w string]];
			i++;
		}
	}
	
}

-(void) addWord:(FWord*) word
{
	[pyDict addWord:word];
}

-(void) addWords:(NSArray*) ws
{
	[pyDict addWords:ws];
}

-(void) removeWord:(FWord *)word
{
	[pyDict removeWord:word];
}

-(NSArray*) userWords
{
	return [pyDict userWords];
}

-(NSArray*) userWordsForPost
{
	return [pyDict userWordsForPost];
}

-(void) userWordsPostDone
{
	[pyDict userWordsPostDone];
}


-(void) saveUserWords
{
	[pyDict saveUserWords];
}

- (void) dealloc
{
	[tree release];
	[dtree release];
	[list release];
	[pyDict release];
	[numSet release];
	[numString release];
	[super dealloc];
}


@end
