//
//  FPYUtils.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-22.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FPYUtils.h"
#import "FPYWord.h"
#import "FSPScheme.h"

NSArray* PIN_YIN_ARRAY;
NSSet* PIN_YIN_ARRAY_SET;
NSDictionary* PIN_YIN_NUM_DICT;
NSMutableSet* PIN_YIN_SET;


NSArray* PIN_YIN_Z_SET;
NSArray* PIN_YIN_S_SET;
NSArray* PIN_YIN_C_SET;
NSArray* PIN_YIN_LN_SET;
NSArray* PIN_YIN_FH_SET;
NSArray* PIN_YIN_IAN_SET;
NSArray* PIN_YIN_UAN_SET;
NSArray* PIN_YIN_EN_SET;
NSArray* PIN_YIN_IN_SET;

BOOL PIN_YIN_Z_MH;
BOOL PIN_YIN_S_MH;
BOOL PIN_YIN_C_MH;
BOOL PIN_YIN_LN_MH;
BOOL PIN_YIN_FH_MH;
BOOL PIN_YIN_AN_MH;
BOOL PIN_YIN_IAN_MH;
BOOL PIN_YIN_UAN_MH;
BOOL PIN_YIN_EN_MH;
BOOL PIN_YIN_IN_MH;

FPYMode PIN_YIN_CURRENT_MODE;



NSMutableArray* SP_SCHEME_ARRAY;
FSPScheme* SP_CURRENT_SCHEME;



NSString* replace(NSString* yin, NSString* y1, NSString* y2, BOOL prefix);
BOOL handleMHYin(NSString* yin,NSString* yin1, NSString* yin2, BOOL prefix,NSMutableArray* res, NSMutableSet* added);
BOOL only_an_ang(NSString* yin);
void reload_pinyin_set();
void LoadSPData (NSMutableArray* res, const char* filename);

@implementation FPYUtils

//Initializes the receiver before it’s used (before it receives its first message).
+ (void)initialize
{
	NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
	PIN_YIN_ARRAY = [[NSArray alloc] initWithObjects:
		@"a",@"ai",@"an",@"ang",@"ao",@"ba",@"bai",@"ban",@"bang",@"bao",
		@"bei",@"ben",@"beng",@"bi",@"bian",@"biao",@"bie",@"bin",@"bing",@"bo",
		@"bu",@"ca",@"cai",@"can",@"cang",@"cao",@"ce",@"cen",@"ceng",@"ci",@"cong",@"cou",
		@"cu",@"cuan",@"cui",@"cun",@"cuo",@"cha",
		@"chai",@"chan",@"chang",@"chao",@"che",@"chen",@"cheng",@"chi",@"chong",@"chou",
		@"chu",@"chuai",@"chuan",@"chuang",@"chui",@"chun",@"chuo",@"da",@"dai",@"dan",@"dang",@"dao",
		@"de",@"dei",@"den",@"deng",@"di",@"dia",@"dian",@"diao",@"die",@"ding",
		@"diu",@"dong",@"dou",@"du",@"duan",@"dui",@"dun",@"duo",@"e",@"ei",
		@"en",@"er",@"fa",@"fan",@"fang",@"fei",@"fen",@"feng",@"fo",@"fou",
		@"fu",@"ga",@"gai",@"gan",@"gang",@"gao",@"ge",@"gei",@"gen",@"geng",
		@"gong",@"gou",@"gu",@"gua",@"guai",@"guan",@"guang",@"gui",@"gun",@"guo",
		@"ha",@"hai",@"han",@"hang",@"hao",@"he",@"hei",@"hen",@"heng",@"hong",
		@"hou",@"hu",@"hua",@"huai",@"huan",@"huang",@"hui",@"hun",@"huo",@"ji",
		@"jia",@"jian",@"jiang",@"jiao",@"jie",@"jin",@"jing",@"jiong",@"jiu",@"ju",
		@"juan",@"jue",@"jun",@"ka",@"kai",@"kan",@"kang",@"kao",@"ke",@"kei",
		@"ken",@"keng",@"kong",@"kou",@"ku",@"kua",@"kuai",@"kuan",@"kuang",@"kui",
		@"kun",@"kuo",@"la",@"lai",@"lan",@"lang",@"lao",@"le",@"lei",@"leng",
		@"li",@"lia",@"lian",@"liang",@"liao",@"lie",@"lin",@"ling",@"liu",@"lo",
		@"long",@"lou",@"lu",@"luan",@"lue",@"lun",@"luo",@"lv",@"lve",@"ma",
		@"mai",@"man",@"mang",@"mao",@"me",@"mei",@"men",@"meng",@"mi",@"mian",
		@"miao",@"mie",@"min",@"ming",@"miu",@"mo",@"mou",@"mu",@"na",@"nai",
		@"nan",@"nang",@"nao",@"ne",@"nei",@"nen",@"neng",@"ni",@"nian",@"niang",
		@"niao",@"nie",@"nin",@"ning",@"niu",@"nong",@"nou",@"nu",@"nuan",@"nue",
		@"nuo",@"nv",@"nve",@"o",@"ou",@"pa",@"pai",@"pan",@"pang",@"pao",
		@"pei",@"pen",@"peng",@"pi",@"pian",@"piao",@"pie",@"pin",@"ping",@"po",
		@"pou",@"pu",@"qi",@"qia",@"qian",@"qiang",@"qiao",@"qie",@"qin",@"qing",
		@"qiong",@"qiu",@"qu",@"quan",@"que",@"qun",@"ran",@"rang",@"rao",@"re",
		@"ren",@"reng",@"ri",@"rong",@"rou",@"ru",@"ruan",@"rui",@"run",@"ruo",
		@"sa",@"sai",@"san",@"sang",@"sao",@"se",@"sen",@"seng",@"si",@"song",@"sou",
		@"su",@"suan",@"sui",@"sun",@"suo",@"sha",@"shai",
		@"shan",@"shang",@"shao",@"she",@"shei",@"shen",@"sheng",@"shi",@"shou",@"shu",
		@"shua",@"shuai",@"shuan",@"shuang",@"shui",@"shun",@"shuo",@"ta",@"tai",@"tan",@"tang",@"tao",
		@"te",@"tei",@"teng",@"ti",@"tian",@"tiao",@"tie",@"ting",@"tong",@"tou",
		@"tu",@"tuan",@"tui",@"tun",@"tuo",@"wa",@"wai",@"wan",@"wang",@"wei",
		@"wen",@"weng",@"wo",@"wu",@"xi",@"xia",@"xian",@"xiang",@"xiao",@"xie",
		@"xin",@"xing",@"xiong",@"xiu",@"xu",@"xuan",@"xue",@"xun",@"ya",@"yan",
		@"yang",@"yao",@"ye",@"yi",@"yin",@"ying",@"yo",@"yong",@"you",@"yu",
		@"yuan",@"yue",@"yun",@"za",@"zai",@"zan",@"zang",@"zao",@"ze",@"zei",
		@"zen",@"zeng",@"zi",@"zong",@"zou",@"zu",@"zuan",@"zui",@"zun",@"zuo",@"zha",@"zhai",@"zhan",@"zhang",@"zhao",@"zhe",@"zhen",@"zheng",
		@"zhi",@"zhong",@"zhou",@"zhu",@"zhua",@"zhuai",@"zhuan",@"zhuang",@"zhui",@"zhun",
		@"zhuo",nil];
	int i;
	NSMutableArray* num_array = [[NSMutableArray alloc] initWithCapacity:[PIN_YIN_ARRAY count]];
	for (i = 1; i <= [PIN_YIN_ARRAY count]; i++) {
		NSNumber* num = [[NSNumber alloc] initWithInt:i];
		[num_array addObject:num];
		[num release];
	}
	PIN_YIN_NUM_DICT = [[NSDictionary alloc] initWithObjects:num_array forKeys:PIN_YIN_ARRAY];
	
	[num_array release];	
	
	PIN_YIN_Z_SET = [[NSArray alloc] initWithObjects:@"zhei",@"zua",@"zuai",@"zuang",nil]  ;
	PIN_YIN_S_SET = [[NSArray alloc] initWithObjects:@"sei",@"sua",@"suai",@"suang",@"shong",nil]  ;
	PIN_YIN_C_SET = [[NSArray alloc] initWithObjects:@"cuai",@"cuang",nil]  ;
	PIN_YIN_LN_SET = [[NSArray alloc] initWithObjects:@"nia",@"nun",@"len",nil]  ;
	PIN_YIN_FH_SET = [[NSArray alloc] initWithObjects:@"fai",@"fao",@"fe",@"fong",@"fua", @"fuai",@"fuan",@"fuang",@"fui",@"fun",@"fuo",nil]  ;
	PIN_YIN_IAN_SET = [[NSArray alloc] initWithObjects:@"biang", @"diang", @"miang", @"piang", @"tiang",nil]  ;
	PIN_YIN_UAN_SET =[[NSArray alloc] initWithObjects:@"cuang",@"duang",@"juang",@"luang",@"nuang",@"quang",@"ruang",@"suang",@"tuang",@"xuang",@"yuang",@"zuang",nil]  ;
	PIN_YIN_EN_SET = [[NSArray alloc] initWithObjects:@"eng",@"len",@"ten",nil]  ;
	PIN_YIN_IN_SET = [[NSArray alloc] initWithObjects:@"din",@"tin",nil]  ;	
	
	PIN_YIN_SET = [[NSMutableSet alloc] init];
	
	PIN_YIN_ARRAY_SET = [[NSSet alloc] initWithArray:PIN_YIN_ARRAY];
	
	SP_SCHEME_ARRAY = [[NSMutableArray alloc] init];
	
	PIN_YIN_CURRENT_MODE = FQPMode;
	
	reload_pinyin_set();
	
	[tmp_pool release];
}

// return code respect for py

+(UInt32) codeIndexFor:(NSString*) py
{
	NSNumber* num = [PIN_YIN_NUM_DICT objectForKey:py];
	if(!num) return 0;
	return [num intValue];
}

//feng'hua'jun revert to jun'hua'feng

+(NSString*) revertPYString: (NSString*) str
{
	NSMutableString* tmpStr = [NSMutableString string];
	NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
	NSArray* tmpArray = [str componentsSeparatedByString:@"'"];
	int i=0;
	for(i=[tmpArray count]-1;i>=0;i--){
		if([tmpStr length]>0) [tmpStr appendString:@"'"];
		[tmpStr appendString:[tmpArray objectAtIndex:i]];
	}
	[tmp_pool release];
	return tmpStr;
}


//a'a'a return 111

+(UInt32) getCodeIndexs:(UInt32 *) cc byPYString:(NSString*) str
{
	NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
	NSArray* tmpArray = [str componentsSeparatedByString:@"'"];
	UInt32 len=0,r;
	int i=0;
	for(i=[tmpArray count]-1;i>=0;i--){
		r = [FPYUtils codeIndexFor:[tmpArray objectAtIndex:i]];
		if(r==0){
			len=0;
			break;
		}
		cc[len] = r;
		len++;
	}
	
	[tmp_pool release];
	//NSLog(@"%@ %d",str,len);
	return len;
}

// return 0 if str is ilegal;

+(UInt32) getMutiCodeIndexs:(UInt32 *) xcc byPYString:(NSString*) str
{
	NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
	NSArray* tmpArray = [str componentsSeparatedByString:@"'"];
	UInt32 r;
	UInt32 len = 0;
	int i=0,j=0;
	for(i=[tmpArray count]-1;i>=0;i--){
		NSString* y = [tmpArray objectAtIndex:i];
		NSArray* ys = [FPYUtils mutipleCodeElement:y];
		//NSLog(@"%@ %@",y,ys);
		if(ys == nil || [ys count] == 0){
				return 0;
		}
		//NSLog(@"%@ %@",y,ys);
		NSEnumerator* e = [ys objectEnumerator];
		NSString* ty;
		while(ty = [e nextObject]){
			r = [FPYUtils codeIndexFor:ty];
			if(r==0) continue;
			xcc[j] = r;
			j++;
		}
		xcc[j] = 0;
		j++;
		len++;
	}
	xcc[j] = 0;
	j++;
	xcc[j] = 0;
	/*
	i=0;
	while(!(xcc[i]==0&&xcc[i+1]==0)){
		printf("xcc[%d]=%d\n",i,xcc[i]);
		i++;
	}
	*/
	[tmp_pool release];
	//NSLog(@"%@ %d",str,len);
	return len;
}

+(FWord*) guestFirstWordWithMutiCodeIndexs:(UInt32 *) xcc withFirstWord:(FWord*) w withTree:(FTree*) tree withList:(FList*) list withDynamicTree:(FDynamicTree*) dtree
{
	
	UInt32 ii,uilen, ilen,count,oLen;
	UInt32 res[102400];
	int i;
	i=0;
	
	#ifndef IPHONE
	int j;
	if([[w string] length] >= 3){
		while(!(xcc[i]==0&&xcc[i+1]==0)) i++;
		j=0;
		while(YES){
			if(xcc[i]==0){
				j++;
				if(j >[[w string] length]) break;
			}
			i--;
		}
		xcc[i+1] = 0;
	}
	
	#endif
	
	ii=0;
	NSMutableArray* ws = [NSMutableArray array];
	
	while(xcc[ii]!=0){
		//NSLog(@"ii=%d",ii);
		
		FPYWord* umax = nil;
		
		//search dtree fist
		
		NSArray* words = [dtree wordsByMutiCodeIndexs:&xcc[ii] returnIndex:&uilen];
		if(words!=nil && [words count]!=0){
			for(i=0;i<[words count];i++){
				//NSLog(@"hit in db %@",words);
				FPYWord* w = [words objectAtIndex:i];
				if(!umax) umax = w;
				else
				{
					if([w compare:umax]==NSOrderedAscending) umax = w;
				}
			}
		}
		
		FPYWord* max = nil;
		
		count = [tree searchByMutiCodeIndexs:&xcc[ii] result:res returnLength:&oLen returnIndex:&ilen];
		//NSLog(@"xcc[%d+%d]=%d",ii,ilen,xcc[ii+ilen]);
		//ii+=ilen;
		for(i=0;i<count;i++){
			NSString* code = [self codeForCodeIndexs:&res[i*(oLen+1)] length:oLen];
			NSArray* words = [list wordArrayByIndex:res[i*(oLen+1)+oLen] withLength:oLen limit:1];
			if(![words count]) continue;
			FPYWord* w = [words objectAtIndex:0];
			[w setCode:code];
			if(!max) max = w;
			else
			{
				if([w compare:max]==NSOrderedAscending) max = w;
			}
		}
	
		if(umax && [[umax string] length] > [[max string] length]){
			[ws addObject:umax];
			ii += uilen;
		}else{
			[ws addObject:max];
			ii += ilen;
		}
		//NSLog(@"max=%@ %d %d",max,ii,oLen);
	}
	
	if(![ws count]) return nil;
	FWord* cmax = [ws objectAtIndex:[ws count]-1];
	for(i=[ws count]-2;i>=0;i--){
		cmax = [cmax wordCombineWith:[ws objectAtIndex:i]];
	}
	
	if([[w string] length] >= 3){
		cmax = [w wordCombineWith:cmax];
	}
	
	return cmax;
}

+(NSArray*) searchWordsByMutiCodeIndexs:(UInt32 *) xcc withTree:(FTree*) tree withList:(FList*) list withDynamicTree:(FDynamicTree*) dtree
{
	
	int limitCount = 4;
	
	if(PIN_YIN_CURRENT_MODE > FQPMode) limitCount = 8;
	
	UInt32 ii,ilen,count,oLen;
	UInt32 res[102400];
	int i;
		
	ii=0;
	NSMutableArray* ws = [NSMutableArray array];
	NSMutableSet* addedSet = [NSMutableSet set];
	
	while(xcc[ii]!=0){

		int limitFlag= 0;
		int lcount = 0;
		while(xcc[ii+lcount]!=0)lcount++;
		#ifdef IPHONE
		if(ii!=0 && xcc[ii+lcount+1]==0) break; 
		#endif
		if(lcount > limitCount) limitFlag = 1;
	
		//search dtree fist
		
		NSArray* words = [dtree wordsByMutiCodeIndexs:&xcc[ii] returnIndex:&ilen];
		if(xcc[ii+ilen]==0 && words!=nil && [words count]!=0){
			
			for(i=0;i<[words count];i++){
				FPYWord* w = [words objectAtIndex:i];
				if(![addedSet containsObject:[w string]]){
					[addedSet addObject:[w string]];
					[ws addObject:w];
				}
			}
			//NSLog(@"hit2 in db %@",ws);
		}

		#ifdef IPHONE
		if(!limitFlag){ 
		#endif
		
		//search static tree
		

		//NSLog(@"here");
		count = [tree searchByMutiCodeIndexs:&xcc[ii] result:res returnLength:&oLen returnIndex:&ilen];
		//NSLog(@"count=%d",count);
		//NSLog(@"xcc[%d+%d]=%d",ii,lcount,xcc[ii+lcount]);
		//NSLog(@"xcc[%d+%d],count=%d",ii,ilen,count);
		if(xcc[ii+ilen]==0) {
			for(i=0;i<count;i++){
				NSString* code = [FPYUtils codeForCodeIndexs:&res[i*(oLen+1)] length:oLen];
				//NSLog(@"code=%@",code);
				words = [list wordArrayByIndex:res[i*(oLen+1)+oLen] withLength:oLen limit:limitFlag];
				//NSLog(@"hit in static tree %@",words);
				//NSLog(@"hit2 in db %@",ws);
				if(![words count]) continue;
				NSEnumerator* e = [words objectEnumerator];
				FPYWord* w;
				while(w = [e nextObject]) {
					if([addedSet containsObject:[w string]]) continue;
					[w setCode:code];
					[ws addObject:w];
					//NSLog(@"added = %@", w);
				}
			}
		}
		
		#ifdef IPHONE
		} 
		#endif
		
		ii+=lcount+1;
		//ii++;
	}
	//NSLog(@"res = %@", ws);
	return ws;
}

+(NSArray*) searchWordsByMutiCodeIndexs:(UInt32 *) xcc withDynamicTreeOnly:(FDynamicTree*) dtree
{

	UInt32 ii,ilen;
	int i;
		
	ii=0;
	NSMutableArray* ws = [NSMutableArray array];
	NSMutableSet* addedSet = [NSMutableSet set];
	
	while(xcc[ii]!=0){
	
		int lcount = 0;
		while(xcc[ii+lcount]!=0)lcount++;
		if(ii!=0 && xcc[ii+lcount+1]==0) break; 
		//search dtree fist
		
		NSArray* words = [dtree wordsByMutiCodeIndexs:&xcc[ii] returnIndex:&ilen];
		if(xcc[ii+ilen]==0 && words!=nil && [words count]!=0){
			
			for(i=0;i<[words count];i++){
				FPYWord* w = [words objectAtIndex:i];
				if(![addedSet containsObject:[w string]]){
					[addedSet addObject:[w string]];
					[ws addObject:w];
				}
			}
			//NSLog(@"hit2 in db %@",ws);
		}
		
		ii+=lcount+1;
		//ii++;
	}
	//NSLog(@"res = %@", ws);
	return ws;
	
}


+(NSString*) codeForCodeIndexs:(UInt32*) cc length:(UInt32) len
{
	int i;
	NSMutableString* str = [NSMutableString string];
	//NSLog(@"clen=%d",len);
	i=len-1;
	while(i>=0){
		//NSLog(@"cc[%d]=%d",i,cc[i]);
		NSString* tmp = [PIN_YIN_ARRAY objectAtIndex:cc[i]-1];
		if([str length]) [str appendString:@"'"];
		[str appendString:tmp];
		i--;
	}
	return str;
}

+(NSString*) codeForCodeIndex:(UInt32) c
{
	if(c<=0 || c > [PIN_YIN_ARRAY count]) return @"";
	return [PIN_YIN_ARRAY objectAtIndex:c-1];
}

+(NSString *) fixInputString:(NSString *) s
{
	
	NSMutableString* str = [[NSMutableString alloc] initWithString:s];
	[str autorelease];
	
	if([str length]<2) return str;
	
	NSCharacterSet* nonLetterSet = [[NSCharacterSet lowercaseLetterCharacterSet] invertedSet];
	
	if(PIN_YIN_CURRENT_MODE > FQPMode) 
		nonLetterSet = [NSCharacterSet characterSetWithCharactersInString:@"'" ];
	
	int p = 0;
	int len = [str length];
	if(len>6)len=6;
	NSRange range;
	
	
	
	while(p<[str length]){
		while(len>0){
			range.location = PIN_YIN_CURRENT_MODE < FSPMode ? ([str length] - p - len) : p;
			range.length = len;
			NSString * tmp = [str substringWithRange:range];
			NSRange r = [tmp rangeOfCharacterFromSet:nonLetterSet];
			if(r.location==NSNotFound && (len==1||[PIN_YIN_SET containsObject:tmp]
			       ||[tmp isEqualToString:@"zh"]||[tmp isEqualToString:@"sh"]||[tmp isEqualToString:@"ch"])){
				if( PIN_YIN_CURRENT_MODE < FSPMode )
				{  
					if(range.location!=0&&[str characterAtIndex:range.location-1]!='\'')[str insertString:@"'" atIndex:range.location];
					p+=len;
				}else{
					p+=len;
					if(p<[str length]&&[str characterAtIndex:p]!='\'')[str insertString:@"'" atIndex:p];
				}
				break;
			}
			len--;
		}
		p++;
		len=[str length] - p;
		if(len>6)len=6;
	}
	
	return str;
}

+(void) setMH:(BOOL)f forKey:(NSString*) key
{
	if([key isEqualToString:@"z-zh"]){
		PIN_YIN_Z_MH = f;
	}else if([key isEqualToString:@"s-sh"]){
		PIN_YIN_S_MH = f;	
	}else if([key isEqualToString:@"c-ch"]){
		PIN_YIN_C_MH = f;
	}else if([key isEqualToString:@"l-n"]){
		PIN_YIN_LN_MH = f;
	}else if([key isEqualToString:@"f-h"]){
		PIN_YIN_FH_MH = f;
	}else if([key isEqualToString:@"an-ang"]){
		PIN_YIN_AN_MH = f;
	}else if([key isEqualToString:@"ian-iang"]){
		PIN_YIN_IAN_MH = f;
	}else if([key isEqualToString:@"uan-uang"]){
		PIN_YIN_UAN_MH = f;
	}else if([key isEqualToString:@"en-eng"]){
		PIN_YIN_EN_MH = f;
	}else if([key isEqualToString:@"in-ing"]){
		PIN_YIN_IN_MH = f;
	}
	reload_pinyin_set();
}


+(void) setMHByDictionary:(NSDictionary*) dict
{
	NSNumber* n;
	n = [dict objectForKey:@"z-zh"];
	if(n) PIN_YIN_Z_MH = [n boolValue];
	else PIN_YIN_Z_MH = NO;

	n = [dict objectForKey:@"s-sh"];
	if(n) PIN_YIN_S_MH = [n boolValue];
	else PIN_YIN_S_MH = NO;
	
	n = [dict objectForKey:@"c-ch"];
	if(n) PIN_YIN_C_MH = [n boolValue];
	else PIN_YIN_C_MH = NO;
	
	n = [dict objectForKey:@"l-n"];
	if(n) PIN_YIN_LN_MH = [n boolValue];
	else PIN_YIN_LN_MH = NO;
	
	n = [dict objectForKey:@"f-h"];
	if(n) PIN_YIN_FH_MH = [n boolValue];
	else PIN_YIN_FH_MH = NO;
	
	n = [dict objectForKey:@"an-ang"];
	if(n) PIN_YIN_AN_MH = [n boolValue];
	else PIN_YIN_AN_MH = NO;
	
	n = [dict objectForKey:@"ian-iang"];
	if(n) PIN_YIN_IAN_MH = [n boolValue];
	else PIN_YIN_IAN_MH = NO;
	
	n = [dict objectForKey:@"uan-uang"];
	if(n) PIN_YIN_UAN_MH = [n boolValue];
	else PIN_YIN_UAN_MH = NO;
	
	n = [dict objectForKey:@"en-eng"];
	if(n) PIN_YIN_EN_MH = [n boolValue];
	else PIN_YIN_EN_MH = NO;
	
	n = [dict objectForKey:@"in-ing"];
	if(n) PIN_YIN_IN_MH = [n boolValue];
	else PIN_YIN_IN_MH = NO;
	
	reload_pinyin_set();
}

+(NSArray *) mutipleCodeElement:(NSString *) ce
{
	if(PIN_YIN_CURRENT_MODE < FSPMode){
		return [FPYUtils qpMutipleCodeElement:ce];
	}else{
		if([ce isEqualToString:@";"]) ce = @"l";
		if([ce length] != 2) return [FPYUtils qpMutipleCodeElement:ce];
		NSArray* qpArr = [SP_CURRENT_SCHEME qpBySp:ce];
		if(!qpArr||[qpArr count]==0) return [FPYUtils qpMutipleCodeElement:ce];
		int i;
	
		NSMutableSet* res = [[NSMutableSet alloc] init];
	
		if([PIN_YIN_ARRAY_SET containsObject:ce])
			[res addObject:ce];
	
	
		for(i=0;i<[qpArr count];i++)
		{
			if([PIN_YIN_ARRAY_SET containsObject:[qpArr objectAtIndex:i]])
				[res addObjectsFromArray:[FPYUtils qpMutipleCodeElement:[qpArr objectAtIndex:i]]];
		}
	
		if([res count]==0){
			NSArray* qpArr2 =  [FPYUtils qpMutipleCodeElement:ce];
			if(qpArr2)
				[res addObjectsFromArray:qpArr2];
		}

		//NSLog(@"%@=%@",ce, res);
		return [res allObjects] ;
		
	}
}

+(NSArray *) qpMutipleCodeElement:(NSString *) ce
{
	//NSLog(@"mhing %@",ce);
	NSString* y = ce;
	NSMutableArray* res = [[NSMutableArray alloc] init];
	NSMutableSet* added = [NSMutableSet set];
	[res autorelease];
	if([PIN_YIN_ARRAY_SET containsObject:y] || ([ce length] != 1 && ![ce isEqualToString:@"zh"] && ![ce isEqualToString:@"sh"] && ![ce isEqualToString:@"ch"] )){
		[res addObject:y];
	}else{
		NSEnumerator *enumerator = [PIN_YIN_ARRAY objectEnumerator];
		NSString* str;
		BOOL start = NO;
		while ( str = [enumerator nextObject] ) {
			if([str hasPrefix:y]){
				start=YES;
				//NSLog(@"add %@",str);
				[res addObject:str];
			} else if(start) break;
		}
		//return empty array
		if(!start) return res;
	}

	[added addObjectsFromArray:res];
	//NSLog(@"res_start %@",res);
	
	int count = [res count];
	int i;

	for(i=0;i<count;i++){
		NSString* y_str = [res objectAtIndex:i];
		//prefix
		BOOL match = NO;
		if(PIN_YIN_Z_MH&&!match) match=handleMHYin(y_str,@"z",@"zh",YES,res,added);
		if(PIN_YIN_S_MH&&!match) match=handleMHYin(y_str,@"s",@"sh",YES,res,added);
		if(PIN_YIN_C_MH&&!match) match=handleMHYin(y_str,@"c",@"ch",YES,res,added);
		if(PIN_YIN_LN_MH&&!match) match=handleMHYin(y_str,@"l",@"n",YES,res,added);
		if(PIN_YIN_FH_MH&&!match) match=handleMHYin(y_str,@"f",@"h",YES,res,added);
		//subfix
		if(match){
			match = NO;
			NSString* y_str2 = [res objectAtIndex:[res count]-1];
			//NSLog(@"y_str2=%@",y_str2);
			if(PIN_YIN_IAN_MH&&!match) match=handleMHYin(y_str2,@"ian",@"iang",NO,res,added);
			if(PIN_YIN_UAN_MH&&!match) match=handleMHYin(y_str2,@"uan",@"uang",NO,res,added);
			if(PIN_YIN_AN_MH&&!match) {
				
				//handle specially
				if(only_an_ang(y_str2))	match=handleMHYin(y_str2,@"an",@"ang",NO,res,added);
			}
			if(PIN_YIN_EN_MH&&!match) match=handleMHYin(y_str2,@"en",@"eng",NO,res,added);
			if(PIN_YIN_IN_MH&&!match) match=handleMHYin(y_str2,@"in",@"ing",NO,res,added);
		}
		
		match = NO;
		//if(!match) match=handleMHYin(y_str,@"ian",@"iang",NO,res,added);
		if(PIN_YIN_IAN_MH&&!match) match=handleMHYin(y_str,@"ian",@"iang",NO,res,added);
		if(PIN_YIN_UAN_MH&&!match) match=handleMHYin(y_str,@"uan",@"uang",NO,res,added);
		if(PIN_YIN_AN_MH&&!match) {
			//handle specially
			if(only_an_ang(y_str))	match=handleMHYin(y_str,@"an",@"ang",NO,res,added);
		}
		if(PIN_YIN_EN_MH&&!match) match=handleMHYin(y_str,@"en",@"eng",NO,res,added);
		if(PIN_YIN_IN_MH&&!match) match=handleMHYin(y_str,@"in",@"ing",NO,res,added);
	}
	//NSLog(@"res=%@",res);
	//MHPY process here
	return res;

}


+(BOOL) isPY:(NSString*) str
{
	return [PIN_YIN_SET containsObject:str];
}

//----------------- SP function here ----------------------------

+(void) loadSPSchemesFromFile:(NSString*) path
{
	LoadSPData(SP_SCHEME_ARRAY, [path fileSystemRepresentation]);
}


+(NSArray*) supportedSPSchemes
{
	NSMutableArray* res = [NSMutableArray array];
	NSEnumerator* e = [SP_SCHEME_ARRAY objectEnumerator];
	FSPScheme* s;
	while(s = [e nextObject]) [res addObject:[s name]];
	return res;
}

+(NSString*) currentSPSchemeName
{
	return [SP_CURRENT_SCHEME name];
}

+(void) selectSPScheme:(NSString*) name
{
	if([name isEqualToString:@""]) return;
	NSEnumerator* e = [SP_SCHEME_ARRAY objectEnumerator];
	FSPScheme* s;
	while(s = [e nextObject]){
		if([[s name] isEqualToString:name]){
			SP_CURRENT_SCHEME = s;
			//NSLog(@"select %@",[SP_CURRENT_SCHEME name]);
			//NSLog(@"dict=",[SP_CURRENT_SCHEME )
			break;
		}
	}
	reload_pinyin_set();
	//NSLog(@"set=%@",PIN_YIN_SET);
}
  

+(void) setPYMode:(FPYMode) m
{
	PIN_YIN_CURRENT_MODE = m;
	if(m >= FSPMode && !SP_CURRENT_SCHEME) {
		SP_CURRENT_SCHEME = [SP_SCHEME_ARRAY objectAtIndex:0];
	}
	reload_pinyin_set();
}

+(FPYMode) currentPYMode
{
	return PIN_YIN_CURRENT_MODE;
}

+(NSSet*) pinYinSet
{
	return PIN_YIN_SET;
}


@end

void reload_pinyin_set(){
	[PIN_YIN_SET removeAllObjects];
	if(PIN_YIN_CURRENT_MODE == FQPMode || PIN_YIN_CURRENT_MODE == FQPSPMode){
		[PIN_YIN_SET addObjectsFromArray:PIN_YIN_ARRAY];
		if(PIN_YIN_Z_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_Z_SET];
		if(PIN_YIN_S_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_S_SET];
		if(PIN_YIN_C_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_C_SET];
		if(PIN_YIN_LN_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_LN_SET];
		if(PIN_YIN_FH_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_FH_SET];
		if(PIN_YIN_IAN_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_IAN_SET];
		if(PIN_YIN_UAN_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_UAN_SET];
		if(PIN_YIN_EN_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_EN_SET];
		if(PIN_YIN_IN_MH) [PIN_YIN_SET addObjectsFromArray:PIN_YIN_IN_SET];
	}
	if(PIN_YIN_CURRENT_MODE >= FSPMode){
		NSEnumerator* e = [PIN_YIN_ARRAY objectEnumerator];
		NSString* y;
		while( y = [e nextObject] )
		{
			NSString* sp = [SP_CURRENT_SCHEME spByQp:y];
			//NSLog(@"y=%@,sp=%@",y,sp);
			if(sp)[PIN_YIN_SET addObject:sp];
		}
	}
}


NSString* replace(NSString* yin, NSString* y1, NSString* y2, BOOL prefix)
{
	NSString* new_str=nil;
	
	if(prefix){
		if([yin hasPrefix:y1] && (![yin hasPrefix:y2] || [y1 length]==2 )){
			new_str = [y2 stringByAppendingString:[yin substringFromIndex:[y1 length]]];
		}
	}else{
		if([yin hasSuffix:y1] && ![yin hasSuffix:y2]){
			int toIndex = [yin length] - [y1 length];
			new_str = [[yin substringToIndex:toIndex] stringByAppendingString:y2];
		}
	}
	return new_str;
}

BOOL handleMHYin(NSString* yin,NSString* yin1, NSString* yin2, BOOL prefix,NSMutableArray* res, NSMutableSet* added){
	NSString* n_yin;
	BOOL match = NO;
	n_yin = replace(yin,yin1,yin2,prefix);
	if(n_yin){
		if(![added containsObject:n_yin]){
			[res addObject:n_yin];
			[added addObject:n_yin];
		}
		match=YES;
	}
	n_yin = replace(yin,yin2,yin1,prefix);
	if(n_yin){
		if(![added containsObject:n_yin]){
			[res addObject:n_yin];
			[added addObject:n_yin];
		}
		match=YES;
	}
	return match;
} 



BOOL only_an_ang(NSString* yin){
	NSRange r = [yin rangeOfCharacterFromSet:[NSCharacterSet characterSetWithCharactersInString:@"iu"]];
	if(r.location == NSNotFound) return YES;
	else return NO;
}


void LoadSPData (NSMutableArray* res, const char* filename)
{
	[res removeAllObjects];
    FILE           *fp;
    char            str[300], strS[5], *pstr;
    int             i;

	
	FSPScheme* spset = nil;
	

    fp = fopen (filename, "rt");

    if (!fp)
	return;

    
    while (1) {
	if (!fgets (str, 300, fp))
	    break;

	i = strlen (str) - 1;
	while (str[i] == ' ' || str[i] == '\n')
	    str[i--] = '\0';
		
	pstr = str;
	if (*pstr == ' ' || *pstr == '\t')
	    pstr++;
	if (!strlen (pstr) || pstr[0] == '#')
	    continue;
	
	char* fstr = "方案名称=";
	int flen = strlen(fstr);
	//printf("%s\n",pstr);
	if (!strncmp(pstr,fstr,flen)) {
		pstr+=flen;
		if (*pstr == ' ' || *pstr == '\t')
			pstr++;
		[spset release];
		spset = [[FSPScheme alloc] init];
		[spset setName:[NSString stringWithUTF8String:pstr]];
		[res  addObject:spset];
		//[spset release];
		continue;
	}
	
	if (pstr[0] == '=')	{ //是零声母设置
	   pstr++;
	   [spset setNonSMKey:[[NSString stringWithUTF8String:pstr] lowercaseString] ];
	   continue;
	
	}else {
	    i = 0;
	    while (pstr[i]) {
		  if (pstr[i] == '=') {
		    strncpy (strS, pstr, i);
		    strS[i] = '\0';
		    pstr += i;
			pstr ++;
			
			NSString* yin = [NSString stringWithUTF8String:strS];
			NSString* key = [[NSString stringWithUTF8String:pstr] lowercaseString];
			
			if([yin isEqualToString:@"zh"] || [yin isEqualToString:@"ch"] || [yin isEqualToString:@"sh"]){
				[spset setSM:yin withKey:key];
			}else{
				[spset setYM:yin withKey:key];
			}
		  }
		  i++;
	    }
	}
	
	
    }
	[spset release];
    fclose (fp);
}

