//
//  FPYWord.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-22.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FPYWord.h"
#import "FPYUtils.h"

@implementation FPYWord

-(NSString*) revertCode
{
	return revertCode;
}


-(void) setCode:(NSString*)c
{
	[super setCode:c];
	[revertCode release];
	NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
	revertCode = [[NSString alloc] initWithString:[FPYUtils revertPYString:code]];
	[tmp_pool release];
}

-(NSComparisonResult) compareRevertCode: (FPYWord *) w
{
	NSComparisonResult r = [[self revertCode] compare:[w revertCode]];
	if(r!=NSOrderedSame) return r;

	if([self freq] > [w freq] )
	{
		return NSOrderedAscending;
	}else if([self freq] < [w freq])
	{
		return NSOrderedDescending;
	}	
	
	return NSOrderedSame;
	
}

-(NSComparisonResult) compare: (FWord *) w
{
	int l1 = [[self string] length];
	int l2 = [[w string] length];
	
	if(l1 > l2 )
	{
		return NSOrderedAscending;
	}else if(l1 < l2)
	{
		return NSOrderedDescending;
	}	


	if([self hit] > [w hit] )
	{
		return NSOrderedAscending;
	}else if([self hit] < [w hit])
	{
		return NSOrderedDescending;
	}	

	if([self freq] > [w freq] )
	{
		return NSOrderedAscending;
	}else if([self freq] < [w freq])
	{
		return NSOrderedDescending;
	}	
	
	return NSOrderedSame;
	
}

-(UInt32) genCodeArray: (UInt32*)cc
{
	return [FPYUtils getCodeIndexs:cc byPYString:code];
}

-(FWord *) wordCombineWith:(FWord *) w
{
	//NSLog(@"py combine");
	//PYWord* nw = [[PYWord alloc] initWithCode:[code stringByAppendingFormat:@"'%@",[w code]]
	//                                                     withString:[string stringByAppendingString:[w string]]];
	FPYWord* nw = [[FPYWord alloc] init];
	[nw setCode:[code stringByAppendingFormat:@"'%@",[w code]]];
	[nw setString:[string stringByAppendingString:[w string]]];
	[nw setNewFlag:YES];
	[nw autorelease];
	return nw;
}


- (void) dealloc
{
	[revertCode release];
	[super dealloc];
}


@end
