//
//  SPSet.m
//  CarbonInputMethod
//
//  Created by Feng Huajun on 4/27/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FSPScheme.h"


@implementation FSPScheme

- (id) init {
	self = [super init];
	if (self != nil) {
		smDict = [[NSMutableDictionary alloc] init];
		ymDict = [[NSMutableDictionary alloc] init];
	}
	return self;
}

-(void) setName: (NSString *) n
{
	[n retain];
	[name release];
	name = n;
}

-(void) setNonSMKey: (NSString *) n
{
	[n retain];
	[non_sm release];
	non_sm = n;
}
-(void) setSM: (NSString *) sm withKey: (NSString *) k
{
	[smDict setObject:k forKey:sm];
}

-(void) setYM: (NSString *) ym withKey: (NSString *) k;
{
	[ymDict setObject:k forKey:ym];
}

-(NSString *) name
{
	return name;
}

-(NSString *) nonSMKey
{
	return non_sm;
}

-(NSArray *) smByKey: (NSString *) k
{
	NSMutableArray* res = [[NSMutableArray alloc] init];
	[res autorelease];
	NSEnumerator* e = [[smDict allKeys] objectEnumerator];
	NSString* s;
	while(s = [e nextObject]){
		NSString* v = [smDict objectForKey:s];
		if([v isEqualToString:k]) [res addObject:s];
	}
	[res addObject:k];
	return res;
}


-(NSArray *) ymByKey: (NSString *) k
{
	NSMutableArray* res = [[NSMutableArray alloc] init];
	[res autorelease];
	NSEnumerator* e = [[ymDict allKeys] objectEnumerator];
	NSString* s;
	while(s = [e nextObject]){
		NSString* v = [ymDict objectForKey:s];
		if([v isEqualToString:k]) [res addObject:s];
	}
	if([k isEqualToString:@"a"]||[k isEqualToString:@"o"]||[k isEqualToString:@"i"]
	||[k isEqualToString:@"u"]||[k isEqualToString:@"e"]||[k isEqualToString:@"v"]) [res addObject:k];
	return res;
}

-(NSString *) keyBySM: (NSString *) sm ;
{
	return [smDict objectForKey:sm];
}

-(NSString *) keyByYM: (NSString *) ym ;
{
	return [ymDict objectForKey:ym];
}

-(NSString *) spByQp:(NSString *) qp
{
	if( [qp isEqualToString:@"a"]||[qp isEqualToString:@"o"]||[qp isEqualToString:@"i"]
	||[qp isEqualToString:@"u"]||[qp isEqualToString:@"e"]||[qp isEqualToString:@"v"]){
		return [non_sm stringByAppendingString:qp];
	}

	NSString* yunmu = [ymDict objectForKey:qp];
	//NSLog(@"ymdict=%@",ymDict);
	if(yunmu){  // 单韵母音节
		return [non_sm stringByAppendingString:yunmu];
	}
	
	NSString* shenmu;
	if([qp hasPrefix:@"ch"] || [qp hasPrefix:@"sh"] || [qp hasPrefix:@"zh"]){
		shenmu = [smDict objectForKey:[qp substringToIndex:2]];
		yunmu = [ymDict objectForKey:[qp substringFromIndex:2]];
		if(!yunmu) yunmu = [qp substringFromIndex:2];
	}else{
		shenmu = [qp substringToIndex:1];
		yunmu = [ymDict objectForKey:[qp substringFromIndex:1]];
		if(!yunmu) yunmu = [qp substringFromIndex:1];
	}
	return [shenmu stringByAppendingString:yunmu];
	
}

-(NSArray *) qpBySp:(NSString *) sp
{
	NSString* shenmu = [sp substringToIndex:1] ;
	NSString* yunmu = [sp substringFromIndex:1] ;
	
	if([shenmu isEqualToString:non_sm])
		return [self ymByKey:yunmu];
	
	NSArray* smArray = [self smByKey:shenmu];

	NSArray* ymArray = [self ymByKey:yunmu];
	
	NSMutableArray* res = [[NSMutableArray alloc] init];
	[res autorelease];
	
	int i,j;
	
	for(i=0;i<[smArray count];i++){
		for(j=0;j<[ymArray count];j++){
			[res addObject:[[smArray objectAtIndex:i] stringByAppendingString:[ymArray objectAtIndex:j]]];
		}
	}
	if(![res count]) return nil;
	return res;
	
}

@end


