//
//  StringEx.m
//  CarbonInputMethod
//
//  Created by Feng Huajun on 4/17/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FStringEx.h"
#include <iconv.h>
#include "jconv.h"

#define OUTLEN 255

int code_convert(const char *from_charset, const char *to_charset, const char *inbuf,int
inlen,char *outbuf,int outlen)
{
iconv_t cd;
//int rc; 
#ifdef IPHONE
const char **pin = (const char **)&inbuf;
#else
char **pin = (char **)&inbuf;
#endif
char **pout = (char **)&outbuf;

cd = iconv_open(to_charset,from_charset);
if (cd==0) return -1;
memset(outbuf,0,outlen);
if (iconv(cd,pin,(size_t*)&inlen,pout,(size_t*)&outlen)==-1) return -1;
iconv_close(cd);
return 0;
}

int u2g(const char *inbuf,int inlen,char *outbuf,int outlen)
{
return code_convert("utf-8","gb2312",inbuf,inlen,outbuf,outlen);
}

int g2u(const char *inbuf,size_t inlen,char *outbuf,size_t outlen)
{
return code_convert("gb2312","utf-8",inbuf,inlen,outbuf,outlen);
}


int b2u(const char *inbuf,size_t inlen,char *outbuf,size_t outlen)
{
return code_convert("BIG5","utf-8",inbuf,inlen,outbuf,outlen);
}

int gb2big_convert(const char *inbuf,int inlen,char *outbuf,int outlen)
{
const char *from_charset = "GBK";
const char *to_charset = "BIG5";
jconv_t cd;
//int rc;
const char **pin = (const char **)&inbuf;
char **pout = (char **)&outbuf;

cd = jconv_open(to_charset,from_charset);
if (cd==0) return -1;
memset(outbuf,0,outlen);
if (jconv(cd,pin,(size_t*)&inlen,pout,(size_t *)&outlen)==-1) return -1;
jconv_close(cd);
return 0;
}

int g2b(char *inbuf,size_t inlen,char *outbuf,size_t outlen)
{
return gb2big_convert(inbuf,inlen,outbuf,outlen);
}

@implementation NSString (StringEx)

-(NSString*) big5String
{
	const char *in_utf8=[self UTF8String];
	char outs[OUTLEN];
	char outss[OUTLEN];
	char outsss[OUTLEN];

	int rc = u2g(in_utf8,strlen(in_utf8),outs,OUTLEN);
	rc = g2b(outs,strlen(outs),outss,OUTLEN);
	rc = b2u(outss,strlen(outss),outsss,OUTLEN);
	
	return [NSString stringWithUTF8String:outsss];
	
}
@end

