//
//  FWBXDictionary.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 08-1-8.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "FWBXDictionary.h"
#import "FWBXUtils.h"

@implementation FWBXDictionary

- (id) initWithIndexFile:(NSString*) idxFile listFile:(NSString*) datFile dbFile:(NSString*) dbFile
{
	self = [super init];
	if (self != nil) {
		tree = [[FTree alloc] initFromFile:[idxFile fileSystemRepresentation]];
		list = [[FList alloc] initFromFile:[datFile fileSystemRepresentation] withType:FWBX];
		dtree = [[FDynamicTree alloc] initFromFile:[dbFile fileSystemRepresentation] withType:FWBX];
	}
	return self;
}

-(NSString *) fixInputString:(NSString *) str
{
	return str;
}

-(NSArray *) searchWordsByFixedString:(NSString *) fixedString
{
	UInt32 p[200];
	UInt32 i,len = 0;
	BOOL zFlag = NO;
	i=0;
	while(i<[fixedString length]){
		//NSLog(@"[fixedString characterAtIndex:%d]=%d",i,[fixedString characterAtIndex:i]);
		if([fixedString characterAtIndex:i]==122){
			zFlag = YES;
			break;
		}
		i++;
	}
	
	if(zFlag){
		len = [FWBXUtils getMutiCodeIndexs:p byPYString:fixedString];
	}else{
		len = [FWBXUtils getCodeIndexs:p byPYString:fixedString];
	}
	
	if(!len) return nil;
	
	
	
	NSArray* res;
	
	if(zFlag){
		res = [FWBXUtils searchWordsByMutiCodeIndexs:p withTree:tree withList:list withDynamicTree:dtree];
	}else{
		res = [FWBXUtils searchWordsByCodeIndexs:p withLength:len withTree:tree withList:list withDynamicTree:dtree];
	}
	
	NSMutableArray* resx = [NSMutableArray arrayWithArray:res];
	[resx sortUsingSelector:@selector(compare:)];
	
	/*
	#ifdef IPHONE
	
	if(!zFlag){
		if([fixedString length] == 2 ){
			[resx addObjectsFromArray:[self searchWordsByFixedString:[fixedString stringByAppendingString:@"z"]]];
			[resx addObjectsFromArray:[self searchWordsByFixedString:[fixedString stringByAppendingString:@"zz"]]];
		}else if([fixedString length] == 3) {
			[resx addObjectsFromArray:[self searchWordsByFixedString:[fixedString stringByAppendingString:@"z"]]];		
		}
	}
	
	#endif
	*/
	
	
	
	return resx;
}

-(void) addWord:(FWord*) word
{
	[dtree addWord:word];
}

-(void) addWords:(NSArray*) ws
{
	int i;
	for(i=0;i<[ws count];i++){
		FWord* w = [ws objectAtIndex:i];
		[self addWord:w];
	}
}

-(void) removeWord:(FWord *)word
{
	[dtree removeWord:word];
}

-(NSArray*) userWords
{
	return [dtree userWords];
}

-(NSArray*) userWordsForPost
{
	return [dtree userWordsForPost];
}

-(void) userWordsPostDone
{
	[dtree userWordsPostDone];
}

-(void) saveUserWords
{
	[dtree updateDBNow:nil];
}

- (void) dealloc
{
	[tree release];
	[list release];
	[dtree release];
	[super dealloc];
}





@end
