//
//  FWBXUtils.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-26.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FWBXUtils.h"


@implementation FWBXUtils

+(UInt32) getCodeIndexs:(UInt32 *) cc byPYString:(NSString*) str
{
	int len = [str length];
	int i=0;
	for(i=0;i<len;i++){
		unichar c = [str characterAtIndex:i];
		cc[i] = c;
	}
	return len;
}

+(UInt32) getMutiCodeIndexs:(UInt32 *) xcc byPYString:(NSString*) str
{
	int len = [str length];
	int i=0,j=0,k,zcount=0;
	for(i=0;i<len;i++){
		unichar c = [str characterAtIndex:i];
		if(c==122){
			if(zcount<3){
				k=0;
				for(k='a';k<'z';k++){
					xcc[j]=k;
					//printf("xcc[%d]=%d\n",j,xcc[j]);
					j++;
				}
				zcount++;
			}
		}else{
			xcc[j] = c;
			//printf("xcc[%d]=%d\n",j,xcc[j]);
			j++;
		}
		xcc[j]=0;
		//printf("xcc[%d]=%d\n",j,xcc[j]);		
		j++;
	}
	xcc[j]=0;
	//printf("xcc[%d]=%d\n",j,xcc[j]);	
	return len;
}

+(UInt32) getBHMutiCodeIndexs:(UInt32 *) xcc byPYString:(NSString*) str
{
	int len = [str length];
	int i=0,j=0,k;
	for(i=0;i<len;i++){
		unichar c = [str characterAtIndex:i];
		if(c=='0'){
				k=0;
				for(k='1';k<='5';k++){
					xcc[j]=k;
					//printf("xcc[%d]=%d\n",j,xcc[j]);
					j++;
				}
		}else{
			xcc[j] = c;
			//printf("xcc[%d]=%d\n",j,xcc[j]);
			j++;
		}
		xcc[j]=0;
		//printf("xcc[%d]=%d\n",j,xcc[j]);		
		j++;
	}
	xcc[j]=0;
	//printf("xcc[%d]=%d\n",j,xcc[j]);	
	return len;
}


+(UInt32) getBHMutiCodeIndexs:(UInt32 *) xcc byMutiString:(NSString*) str
{
	int len = 0;
	int i=0,j=0,k;
	for(i=0;i<[str length];i++){
		unichar c = [str characterAtIndex:i];
		if(c=='0'){
				k=0;
				for(k='1';k<='5';k++){
					xcc[j]=k;
					//printf("xcc[%d]=%d\n",j,xcc[j]);
					j++;
				}
				len++;
		}else if(c>='1' && c<='5'){
			xcc[j] = c;
			//printf("xcc[%d]=%d\n",j,xcc[j]);
			j++;
			len++;
		}else{
			xcc[j]=0;
			//printf("xcc[%d]=%d\n",j,xcc[j]);		
			j++;
		}
	}
	xcc[j]=0;
	j++;
	xcc[j]=0;	
	//printf("xcc[%d]=%d\n",j,xcc[j]);	
	return len;
}


+(NSArray*) searchWordsByCodeIndexs:(UInt32 *) cc withLength:(UInt32) len withTree:(FTree*) tree withList:(FList*) list withDynamicTree:(FDynamicTree*) dtree;
{
	NSMutableArray* res = [NSMutableArray array];
	UInt32 oLen;
	NSMutableSet* addedSet = [NSMutableSet set];
	//static search dtree
	
	NSArray* ws = [dtree wordsByCodeIndexs:cc withLength:len returnLength:&oLen];
	if(len==oLen && ws && [ws count]){
		NSEnumerator* e = [ws objectEnumerator];
		FWord* w;
		while(w = [e nextObject]) {
			if([addedSet containsObject:[w string]]) continue;
			[res addObject:w];
			[addedSet addObject:[w string]];
		}		
	}
	
	//static tree
	
	UInt32 windex = [tree wordIndexByCodeIndexs:cc withLength:len];
	if(windex!=-1){
		NSString* code = [FWBXUtils codeForCodeIndexs:cc length:len];
		ws = [list wordArrayByIndex:windex withLength:0 limit:0];
		NSEnumerator* e = [ws objectEnumerator];
		FWord* w;
		while(w = [e nextObject]) {
			if([addedSet containsObject:[w string]]) continue;
			[w setCode:code];
			[res addObject:w];
				//NSLog(@"added = %@", w);
		}
	}
	
	return res;
}


+(NSArray*) searchWordsByMutiCodeIndexs:(UInt32 *) xcc withTree:(FTree*) tree withList:(FList*) list withDynamicTree:(FDynamicTree*) dtree
{
	UInt32 oLen,oIndex;
	NSMutableArray* ws = [NSMutableArray array];
	NSMutableSet* addedSet = [NSMutableSet set];
	
	NSArray* words = [dtree wordsByMutiCodeIndexs:xcc returnIndex:&oIndex];
	if(xcc[oIndex]==0 && words && [words count]){
		NSEnumerator* e = [words objectEnumerator];
		FWord* w;
		while(w = [e nextObject]) {
			if([addedSet containsObject:[w string]]) continue;
			[ws addObject:w];
			[addedSet addObject:[w string]];
		}		
	}
	
	UInt32 res[100000];
	UInt32 count = [tree searchByMutiCodeIndexs:xcc result:res returnLength:&oLen returnIndex:&oIndex];
	
	int i;
	if(xcc[oIndex]==0){
		for(i=0;i<count;i++){
			NSString* code = [FWBXUtils codeForCodeIndexs:&res[i*(oLen+1)] length:oLen];
			//NSLog(@"code=%@",code);
			NSArray* words = [list wordArrayByIndex:res[i*(oLen+1)+oLen] withLength:oLen limit:0];
			//NSLog(@"hit in static tree %@",words);
			if(![words count]) continue;
			NSEnumerator* e = [words objectEnumerator];
			FWord* w;
			while(w = [e nextObject]) {
				if([addedSet containsObject:[w string]]) continue;
				[w setCode:code];
				[ws addObject:w];
				//NSLog(@"added = %@", w);
			}
		}
	}
	
	return ws;
}

+(NSString*) codeForCodeIndexs:(UInt32*) cc length:(UInt32) len
{
	unichar str[5];
	int i=0;
	for(i=0;i<len;i++){
		str[i] = cc[i];
	}
	return [NSString stringWithCharacters:str length:len];
}

@end
