//
//  FWord.m
//  FunInputToy2.0
//
//  Created by Feng Huajun on 07-12-22.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FWord.h"

BOOL USE_BIG5 = NO;

@implementation FWord

+(void) setUseBig5:(BOOL) f
{
	USE_BIG5 = f;
}

-(NSString*) code
{
	return code;
}

-(NSString*) string
{
	return string;
}

-(NSString*) sstring
{
	return [self description];
}

-(int) freq
{
	return freq;
}

-(int) hit
{
	return hit;
}

-(BOOL) isNew
{
	return isNew;
}

-(BOOL) isSent
{
	return sent;
}


-(int) wordId
{
	return wordId;
}

-(void) setCode:(NSString*)c
{
	[c retain];
	[code release];
	code = c;
}

-(void) setString:(NSString*)s
{
	[s retain];
	[string release];
	string = s;
}

-(void) setFreq:(int)f
{
	freq = f;
}

-(void) setHit:(int)h
{
	hit = h;
}

-(void) setNewFlag:(BOOL)f
{
	isNew = f;
}

-(void) setSentFlag:(BOOL)f
{
	sent = f;
}

-(void) setWordId:(int) i
{
	wordId = i;
}

-(UInt32) genCodeArray: (UInt32*)cc
{
	int len = [code length];
	int i=0;
	for(i=0;i<len;i++){
		unichar c = [code characterAtIndex:i];
		cc[i] = c;
	}
	return len;
}

-(NSString *) description{
		//return [NSString stringWithFormat:@"%@,%@,%d,%d,%d,%d", code, string, hit, freq, isNew, wordId];
	if(USE_BIG5){
	 NSString* s = [string big5String];
	 if(s && ![s isEqualToString:@""] ) return s;
	}
	return string;
}

-(NSComparisonResult) compare: (FWord *) w
{

	if([self hit] > [w hit] )
	{
		return NSOrderedAscending;
	}else if([self hit] < [w hit])
	{
		return NSOrderedDescending;
	}	

	if([self freq] > [w freq] )
	{
		return NSOrderedAscending;
	}else if([self freq] < [w freq])
	{
		return NSOrderedDescending;
	}	
	
	return NSOrderedSame;
	
}

-(NSComparisonResult) compareASCI: (FWord *) w
{
    NSComparisonResult r = [[self code] compare:[w code]];
	if(r!=NSOrderedSame) return r;
	
	if([self freq] > [w freq] )
	{
		return NSOrderedAscending;
	}else if([self freq] < [w freq])
	{
		return NSOrderedDescending;
	}	
	
	return NSOrderedSame;
	
}

-(FWord *) wordCombineWith:(FWord *) w
{
	NSString* prefix_code;
	if([string length]==1){
		prefix_code = [code substringToIndex:2];
	}else if([string length]==2){
		prefix_code = [[code substringToIndex:1] stringByAppendingString:[code substringWithRange:NSMakeRange(2,1)]];
	}else if([string length]>2){
		prefix_code = [code substringToIndex:3];
	}

	NSString* subfix_code;
	if([string length]<=2){
		subfix_code = [[w code] substringToIndex:2];
	}else if([string length]>2){
		subfix_code  = [[w code] substringToIndex:1];
	}

	//WBXWord* nw = [[WBXWord alloc] initWithCode:[prefix_code stringByAppendingString:subfix_code]
    //                                                      withString:[string stringByAppendingString:[w string]]];
	
	FWord* nw = [[FWord alloc] init];
	[nw setCode:[prefix_code stringByAppendingString:subfix_code]];
	[nw setString:[string stringByAppendingString:[w string]]];
	[nw setNewFlag:YES];
	[nw autorelease];
	
	return nw;
}

-(BOOL) isEqualTo:(id) object
{
	FWord* w = object;
	return [code isEqualToString:[w code]] && [string isEqualToString:[w string]];
}

- (void) dealloc
{
	[code release];
	[string release];
	[super dealloc];
}

-(NSString*) toSocketString
{
	return [NSString stringWithFormat:@"%@,%@,%d,%d,%d,%d", code, string, hit, freq, isNew, wordId];
}

@end
