#import <Foundation/Foundation.h>
#import "FMutableTree.h"
#import "FWordFactory.h"
#import "FPYWord.h"
#import "FPYUtils.h"
#import "FWBXUtils.h"
#import "FList.h"
#import "FDynamicTree.h"
#import "FPYDictionary.h"
#import "FWBXDictionary.h"
#import "FRelatedWordList.h"
#import "FConf.h"
#import "FInputEngine.h"
#import "FInputServer.h"

#import <sys/stat.h>
#import <sys/mman.h>
#import <time.h>
#import <sys/timeb.h>
#import <unistd.h>
void loadWordArrayFromFile(NSMutableArray* wordArray, int type, char* filename, int mini){
	
	char dfilename[100];
	strcpy(dfilename, filename);
	strcat(dfilename,".sqlite");
	if(mini!=3)unlink(dfilename);
	FDynamicTree* dtree = [[FDynamicTree alloc] initFromFile:dfilename withType:type];
	char strTemp[500];
	FILE *fps;
	if(mini == 3){
		fps = fopen ("py4.txt", "rt");
	}else{
		fps = fopen (filename, "rt");
	}
	if(!fps) {
		printf("can not open %s", filename);
		return;
	}
	//int sum = 0;
	while (!feof (fps)) {
		if(!fgets(strTemp,499,fps))break;
		
		NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
		
		NSString * sTemp = [NSString stringWithUTF8String:strTemp];
		sTemp = [sTemp stringByTrimmingCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@"\r\n"]];
		NSArray * sTempArray = [sTemp componentsSeparatedByString:@" "] ;
		//if([sTempArray count]<2)continue;
		NSString *sPY = [sTempArray objectAtIndex:0]; 
		NSString *sPhrase =[sTempArray objectAtIndex:1];
		int freq = [[sTempArray objectAtIndex:2] intValue];
		
		FWord* w = [FWordFactory genNewWord:type];
		[w setCode:sPY];
		[w setString:sPhrase];
		[w setFreq:freq];
		/*
		if([[w string] length]==4 && [w freq] == 1){
			sum ++;
			NSLog(@"%d:%@ - %d",sum,w,[w freq]);
		}
		*/
		
		if(mini==1 || mini==3){
			if([[w string] length] == 1 || ([w freq]>10 && [[w string] length] == 2)
			|| ([w freq]>50 && [[w string] length] == 3)
			|| mini==3
			//|| ([w freq]==1 && [[w string] length] == 4)
			){
				[wordArray addObject:w];
				if([[w code] isEqualToString:@"a"] || [[w code] isEqualToString:@"o"] ||[w freq]> 300 || [w freq] == 10){
					/*
					if(mini==3){
						NSLog(@"%@ - %d",w,[w freq]);
					}
					*/
					[dtree addWordToMB:w];
				}
			}
		}else if(mini==2){
			NSString* ss = [w string];
			if([ss length] == 2  && freq > 0){
				[w setCode:[ss substringToIndex:1]];
				[w setString:[ss substringFromIndex:1]];
				[wordArray addObject:w];
			}else if([ss length] == 1 && freq > 100){
				[w setCode:[NSString stringWithUTF8String:"Ａ"]];
				[w setString:ss];
				[wordArray addObject:w];				
			}
		}else{
			[wordArray addObject:w];
		}
		//[w release];
		
		[tmp_pool release];
		
	   }
	
	fclose (fps);
	
	if(mini==1 ||mini==3 ){
		[dtree updateDBNow:nil];
	}else{
		unlink(dfilename);
	}
	
	return;
	
}

void loadBHWordArrayFromFile(NSMutableArray* wordArray, int type, char* filename){
	char strTemp[500];
	FILE *fps = fopen (filename, "rt");
	if(!fps) {
		printf("can not open %s", filename);
		return;
	}
	while (!feof (fps)) {
		if(!fgets(strTemp,499,fps))break;
		
		NSAutoreleasePool * tmp_pool = [[NSAutoreleasePool alloc] init];
		
		NSString * sTemp = [NSString stringWithUTF8String:strTemp];
		sTemp = [sTemp stringByTrimmingCharactersInSet:[NSCharacterSet characterSetWithCharactersInString:@"\r\n"]];
		NSArray * sTempArray = [sTemp componentsSeparatedByString:@" "] ;
		//if([sTempArray count]<2)continue;
		NSString *sPY = [sTempArray objectAtIndex:0]; 
		NSString *sPhrase =[sTempArray objectAtIndex:1];
		
		int i;
		
		for(i = 0;i<[sPhrase length];i++){
			NSRange r = NSMakeRange(i, 1);
			FWord* w = [FWordFactory genNewWord:type];
			[w setCode:sPY];
			[w setString:[sPhrase substringWithRange:r]];
			[w setFreq:[sPhrase length] - i];
			[wordArray addObject:w];
		}
				
		[tmp_pool release];
		
	   }
	
	fclose (fps); 
	
	return;
	
}


void test(char* dataPath)
{
	//NSLog(@"testing");
	NSString* userPath = [NSHomeDirectory() stringByAppendingPathComponent:@".fit"];
	NSFileManager* fs = [NSFileManager defaultManager];
	if(![fs fileExistsAtPath:userPath]){
			[fs createDirectoryAtPath:userPath attributes:nil];
	}			
			
	NSString* conf = [NSHomeDirectory() stringByAppendingString:@"/.fit/fitd.conf"];
	NSMutableDictionary* setting = [NSMutableDictionary dictionaryWithDictionary:[FConf loadSettingFromFile:conf]];

	struct timeb t1,t2;
	char input[1000];
	int i;
	
	FInputEngine* engine;
	
	printf("loading index files....");
	ftime(&t1);
	engine = [[[FInputEngine alloc] initWithDataPath:[NSString stringWithUTF8String:dataPath] withUserPath:userPath withSetting:setting] autorelease];
	ftime(&t2);
	printf("%d ms\n",(t2.time*1000+t2.millitm) - (t1.time*1000+t1.millitm));

	
  for(;;){

	printf("input a test string (or help) >>> ");
	scanf("%s",input);
	
	int inputlen  = strlen(input);
	BOOL mhFlag = NO;
	for(i=0;i<inputlen;i++){
		if(input[i]=='-'){
			mhFlag = YES;
			break;
		}
	}
	
	NSString* test = [NSString stringWithUTF8String:input];
	if([test isEqualToString:@"exit"]) {
		break;
	}

	if([test isEqualToString:@"help"]) {
		printf("just input a string or commands:\n");
		printf("wbx             WBX mode\n");
		printf("bh              BiHua mode\n");
		printf("qp              QuanPin mode\n");
		printf("sp              ShuanPin mode\n");
		printf("qpsp            QuanPin and ShuanPin mix mode\n");
		printf("splist          select a ShuanPin Scheme\n");
		printf("mix             WBX and QuanPin mix mode\n");
		printf("big5            tradational chinese mode\n");
		printf("gb              simplified chinese mode\n");	
		continue;
	}
	
	if([test isEqualToString:@"sp"]) {
		[setting setObject:@"PY" forKey:@"InputMode"];
		[setting setObject:@"SP" forKey:@"PYMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to SP mode\n");
		continue;
	}

	if([test isEqualToString:@"qpsp"]) {
		[setting setObject:@"PY" forKey:@"InputMode"];
		[setting setObject:@"QPSP" forKey:@"PYMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to QPSP mode\n");
		continue;
	}
	
	if([test isEqualToString:@"qp"]) {
		[setting setObject:@"PY" forKey:@"InputMode"];
		[setting setObject:@"QP" forKey:@"PYMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to QP mode\n");
		continue;
	}

	if([test isEqualToString:@"wbx"]) {
		[setting setObject:@"Normal" forKey:@"WBXMode"];
		[setting setObject:@"WBX" forKey:@"InputMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to WBX mode\n");
		continue;
	}

	if([test isEqualToString:@"bh"]) {
		//[setting setObject:@"Normal" forKey:@"WBXMode"];
		[setting setObject:@"BH" forKey:@"InputMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to BH mode\n");
		continue;
	}

	if([test isEqualToString:@"mix"]) {
		[setting setObject:@"Mix" forKey:@"WBXMode"];
		[setting setObject:@"WBX" forKey:@"InputMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to WBX PY MIX mode\n");
		continue;
	}

	if([test isEqualToString:@"num"]) {
		[setting setObject:@"PY" forKey:@"InputMode"];
		[setting setObject:@"NUM" forKey:@"PYMode"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];
		printf("set to PY-NUM mode\n");
		continue;
	}

	if([test isEqualToString:@"big5"]) {
		[FWord setUseBig5:YES];
		printf("set to BIG5 mode\n");
		continue;
	}
	
	if([test isEqualToString:@"gb"]) {
		[FWord setUseBig5:NO];
		printf("set to GB mode\n");
		continue;
	}	
	
	/*
	if([test isEqualToString:@"user"]) {
		//NSArray* uws = [engine userWords];
		//NSLog(@"user words=%@",uws);
		continue;
	}
	*/

	if([test isEqualToString:@"splist"]) {
		NSArray* splist = [FPYUtils supportedSPSchemes];
		NSEnumerator* e = [splist objectEnumerator];
		NSString* s;
		int i=0;
		while(s = [e nextObject]){
			i++;
			printf("%d - %s \n",i, [s UTF8String]);
		}
		
		printf("select:");
		
		char sin[100];
		scanf("%s",sin);
		int select = [[NSString stringWithUTF8String:sin] intValue];
		
		if(select > 0 && select <= i) {
			NSString* spScheme = [splist objectAtIndex:select-1];
			[setting setObject:spScheme forKey:@"SPScheme"];
			[engine reloadSetting:setting];
			[FConf saveSetting:setting toFile:conf];
			printf("set SP scheme to %s \n",[[splist objectAtIndex:select-1] UTF8String]);
			
		}
		
		continue;
	}	
	
	if([test isEqualToString:@"all"]) {
		NSMutableDictionary* mhPYSetting = [NSMutableDictionary dictionaryWithDictionary:[setting objectForKey:@"MHPYSetting"]];
		NSNumber* yes = [NSNumber numberWithInt:YES];
		[mhPYSetting setObject:yes forKey:@"z-zh"];
		[mhPYSetting setObject:yes forKey:@"c-ch"];
		[mhPYSetting setObject:yes forKey:@"s-sh"];
		[mhPYSetting setObject:yes forKey:@"l-n"];
		[mhPYSetting setObject:yes forKey:@"f-h"];
		[mhPYSetting setObject:yes forKey:@"an-ang"];
		[mhPYSetting setObject:yes forKey:@"ian-iang"];
		[mhPYSetting setObject:yes forKey:@"uan-uang"];
		[mhPYSetting setObject:yes forKey:@"en-eng"];
		[mhPYSetting setObject:yes forKey:@"in-ing"];		
		[setting setObject:mhPYSetting forKey:@"MHPYSetting"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];		
		printf("set all MH true done\n");
		continue;
	}
	
	if(mhFlag){
		NSMutableDictionary* mhPYSetting = [NSMutableDictionary dictionaryWithDictionary:[setting objectForKey:@"MHPYSetting"]];
		NSNumber* yes = [NSNumber numberWithInt:YES];
		[mhPYSetting setObject:yes forKey:test];
		[setting setObject:mhPYSetting forKey:@"MHPYSetting"];
		[engine reloadSetting:setting];
		[FConf saveSetting:setting toFile:conf];	
		printf("set %s MH true done\n", input); 
		continue;
	}

	printf("input started search for %s ....\n",[test UTF8String]);
	NSString* fixedString = [engine fixString:test];
	NSMutableString* selectedString = [NSMutableString stringWithString:@""];
	NSMutableArray* selectedWords = [NSMutableArray array];
	do{
		printf("searching for %s ... ", [fixedString UTF8String]);
		ftime(&t1);
		NSArray* res = [engine wordsSearchByFixedString:fixedString];
		ftime(&t2);
		printf("%d ms\n",(t2.time*1000+t2.millitm) - (t1.time*1000+t1.millitm));
		printf("display string: %s%s\n",[selectedString UTF8String],[fixedString UTF8String]);
		printf("candidate words (%d): ", [res count]);
		
		NSEnumerator* e = [res objectEnumerator];
		FWord* w;
		i=1;
		while(w = [e nextObject]){
			printf("%d.%s(%d,%d) ",i,[[w string] UTF8String],[w freq],[w hit]);
			i++;
			if(i>50) {
				printf("...and more..");
				break;
			}
		}
		printf("\n");
		if([res count] == 0 ) break;
		int select;
		char sin[100];
		printf("select a word (1-%d, 0 give up, -x delete):",[res count]);
		scanf("%s",sin);
		select = [[NSString stringWithUTF8String:sin] intValue];
		if(select < 0 && select > -[res count]) {
			FWord* selectWord = [res objectAtIndex:(-select)-1];
			[engine removeWord:selectWord];
			continue;
		}
		if(select < 1 || select > [res count]) break;
		FWord* selectWord = [res objectAtIndex:select-1];

		
		[selectedWords addObject:selectWord];
		[selectedString appendString:[selectWord string]];
		
		if([[setting objectForKey:@"InputMode"] isEqualToString:@"WBX"]) break;
		
		int selectCount = [[selectWord string] length];
		int dotcount=0;
		i=0;	
		while(dotcount < selectCount && i < [fixedString length]){
				//printf("i=%d, c=%d\n",i,[fixedString characterAtIndex:i]);
				if([fixedString characterAtIndex:i]==39) dotcount++;
				i++;
		}
		
		if(i==[fixedString length])break;
		fixedString = [fixedString substringFromIndex:i];
		//NSLog(@"str=%@",fixedString);
	}while(YES);
	
	[engine addWords:selectedWords];
	
	NSArray* relatedWords = [engine relatedWordsByString:selectedString];
		
	NSEnumerator* e = [relatedWords objectEnumerator];
	FWord* w;
	i=1;
	printf("Related: ");
	while(w = [e nextObject]){
		printf("%d.%s(%d,%d) ",i,[[w string] UTF8String],[w freq],[w hit]);
		i++;
		if(i>10) {
			printf("...and more..");
			break;
		}
	}
	printf("\n");

	printf("input string is %s \n",[selectedString UTF8String]);
  
  
  }
}

void print_help(){
	printf("Usage:\n");
	printf(" start the input engine:  fitx &\n");
	printf("					 or:  fitx -f /tmp/fit.sock &\n");
	printf("     create index files:  fitx -p -i py.txt -d /usr/share/fit\n");
	printf("run in engine test mode:  fitx -t -d /usr/share/fit\n");
	printf("Options:\n");
	printf("-h              display this message\n");
	printf("-f socket_file  start engine with the socket_file\n");
	printf("-t              test the input engine\n");
	printf("-p              create PinYin index files\n");
	printf("-s              create small PinYin index files\n");
	printf("-w              create WBX index files\n");
	printf("-r              create Related index files\n");
	printf("-i filename     input filename\n");
	printf("-d dirname      index files dictionary\n");
	exit(0);
}

int main (int argc, char * argv[]) {
	
	
	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	
	int ch;
	int op = -1;
	int type = -1;
	int limit = 0;
	char* input_file = NULL;
	char* output_dir = NULL;
	char* idx_filename = NULL;
	char* dat_filename = NULL;
	char* sock_file="/tmp/fit.sock";
	
	
	
	while((ch = getopt(argc, argv, "bthspwrf:i:d:")) != -1){
	
		//printf("c=%c\n",ch);
		switch(ch){
			case 'h':
				print_help();
				exit(0);
				break;
			case 't':
				op = ch;
				break;
			case 'b':
				type = FWBX;
				op = ch;
				idx_filename = "/bh.idx";
				dat_filename = "/bh.dat";
				break;				
			case 'p':
				type = FPY;
				op = ch;
				idx_filename = "/py.idx";
				dat_filename = "/py.dat";
				break;
			case 'r':
				limit = 2;
				type = FWBX;
				op = ch;
				idx_filename = "/related.idx";
				dat_filename = "/related.dat";
				break;
			case 'w':
				type = FWBX;
				op = ch;
				idx_filename = "/wbx.idx";
				dat_filename = "/wbx.dat";				
				break;
			case 's':
				limit = 1;			
				break;
			case 'f':
				op=ch;
				sock_file = optarg;
				break;
			case 'i':
				input_file = optarg;
				break;
			case 'd':
				output_dir = optarg;
				break;
			case '?':
				printf("unknow option -%c\n",optopt);
				print_help();
				exit(1);				
			default:
				break;
		}
		
		//argc -= optind;
		//argv += optind;
	
	}

	if(argc < 2 || op=='f'){
		FInputServer* s = [[FInputServer alloc] initWithPath:[NSString stringWithUTF8String:sock_file]];
		[s autorelease];
		[s start];
		exit(0);
	}
	
	if(op < 0 ){
		printf("Usage Error!\n");
		print_help();
		exit(1);
	}
	
	if(op == 't'){
		if(!output_dir){
			printf("unknow index files dir\n");
			print_help();
			exit(1);
		}
		test(output_dir);
	}else{

		if(!input_file || !output_dir){
			printf("unknow input file or index files dir\n");
			print_help();
			exit(1);		
		}
	
		char index_file[100];
		char list_file[100];
		strcpy(index_file, output_dir);
		strcat(index_file, idx_filename);
		strcpy(list_file, output_dir);
		strcat(list_file, dat_filename);
	
		NSMutableArray* wordArray = [NSMutableArray array];
		printf("loading %s...\n", input_file);
		if(op=='b'){
			loadBHWordArrayFromFile(wordArray, type, input_file);
		}else{
			loadWordArrayFromFile(wordArray, type,input_file, limit);
			if(limit == 1 && type==FPY){
				printf("loading py4.txt...\n");
				loadWordArrayFromFile(wordArray, type,"py.txt", 3);
			}
		}
		if(op!='b'){
			printf("sorting...\n");
		  if(type==FPY){
			[wordArray sortUsingSelector:@selector(compareRevertCode:)];
		  }else{
			[wordArray sortUsingSelector:@selector(compareASCI:)];
		  }
		}
		printf("building index files(%s,%s)...\n",index_file,list_file);
		[FList saveWordArray:wordArray withType:type toListFile:list_file andIndexFile:index_file];
		printf("done!\n");
	}
	
	[pool release];
    return 0;
}
