/* vim: set expandtab tabstop=4 shiftwidth=4 fdm=marker:
 * +----------------------------------------------------------------------+
 * | J-Convert.                                                           |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2004-2005 Fishchen, China.                             |
 * +----------------------------------------------------------------------+
 * | Authors: Fishchen, China.                                            |
 * |          fishchen <fishchen#gmail.com>                               |
 * +----------------------------------------------------------------------+
 */
/* $Id$ */

/**
 * @note    License: GNU General Public License (GPL) version 2
 * @file    $RCSfile$
 * @version $Revision$
 * @author  $Author$
 * @date    $Date$
 * @brief   Functions define.
 */


#ifndef _JCONV_H_
#define _JCONV_H_


#define JCONV_VER_STR       "0.1.0"
#define JCONV_VER_NUM       100

#define JCONV_CODE_GBK      "GBK"
#define JCONV_CODE_BIG      "BIG5"

#define JCONV_CONV_ERRCODE  -1
#define JCONV_CONV_GBK2BIG  1   ///< GBK  -> BIG5
#define JCONV_CONV_BIG2GBK  2   ///< BIG5 -> GBK


typedef int jconv_t;


/**
 * Open a jconv handle.
 *
 * @param   tocode      Convert to-code.
 * @param   fromcode    Convert from-code.
 * @retval  t_handle    Jconv handle,(-1: error).
 */
jconv_t jconv_open( const char* tocode, const char* fromcode );


/**
 * Convert character code.
 *
 * @param   t_handle    Jconv handle.
 * @param   inbuf       Input buffer.
 * @param   inbytesleft Input buffer left.
 * @retval  t_handle    Jconv handle,(-1: error).
 */
size_t jconv( jconv_t cd,
              const char** inbuf,
              size_t* inbytesleft,
              char**  outbuf,
              size_t* outbytesleft );


/**
 * Close a jconv handle.
 *
 * @param   cd          Jconv handle.
 * @return              0: succ, -1: fail.
 */
int jconv_close( jconv_t cd );


#endif


